import * as React from 'react';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function SvgActivity(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M17.783 5.527a4.695 4.695 0 004.699 4.692c.286-.002.57-.029.852-.082v9.301c0 3.914-2.309 6.229-6.228 6.229H8.571c-3.93 0-6.237-2.316-6.237-6.229v-8.523c0-3.913 2.308-6.248 6.237-6.248h9.295a4.462 4.462 0 00-.083.86zM15.342 17.38l3.334-4.302v-.02a.88.88 0 00-.164-1.22.852.852 0 00-1.21.175l-2.812 3.616-3.2-2.52a.863.863 0 00-1.221.163l-3.447 4.446a.84.84 0 00-.185.533.86.86 0 001.59.502l2.883-3.729 3.2 2.51a.862.862 0 001.232-.154z", fill: "currentColor" }),
        React.createElement("circle", { opacity: 0.4, cx: 22.75, cy: 5.25, fill: "currentColor", r: 2.917 })));
}

function SvgAddUser(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M24.618 11.186h-1.404V9.814c0-.586-.47-1.064-1.048-1.064-.578 0-1.05.478-1.05 1.064v1.372h-1.4c-.58 0-1.05.478-1.05 1.063 0 .586.47 1.064 1.05 1.064h1.4v1.373c0 .586.472 1.064 1.05 1.064.579 0 1.048-.478 1.048-1.064v-1.373h1.404c.578 0 1.049-.478 1.049-1.064 0-.585-.471-1.063-1.049-1.063zM11.084 17.518c-4.72 0-8.75.755-8.75 3.77 0 3.014 4.005 3.795 8.75 3.795 4.718 0 8.75-.754 8.75-3.77 0-3.014-4.006-3.795-8.75-3.795z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M11.084 14.647c3.213 0 5.79-2.61 5.79-5.865 0-3.255-2.577-5.865-5.79-5.865-3.214 0-5.79 2.61-5.79 5.865 0 3.255 2.576 5.865 5.79 5.865z", fill: "currentColor" })));
}

function SvgArrowRight6(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M8.417 15.322l7.99-4.923c.178-.11.407-.099.575.03.759.585 1.437 1.178 1.89 1.676 0 0 .39.399.558.652.272.345.403.797.403 1.236 0 .492-.143.957-.43 1.33-.064.066-.312.36-.545.598-1.363 1.489-4.922 3.948-6.793 4.694-.272.12-1 .371-1.377.385a2.26 2.26 0 01-1.052-.253c-.415-.24-.74-.61-.922-1.05-.117-.306-.298-1.223-.298-1.25-.118-.654-.206-1.574-.249-2.647a.54.54 0 01.25-.479z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M8.951 12.67c-.352.219-.796-.06-.778-.48A27.83 27.83 0 018.377 9.7c.013-.014.194-1.157.403-1.543A2.074 2.074 0 0110.624 7h.064c.495.013 1.547.452 1.547.478.53.22 1.221.594 1.966 1.043a.535.535 0 01.008.908L8.95 12.67z", fill: "currentColor" })));
}

function SvgArrowDownCircle(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M25.667 14c0 6.434-5.234 11.666-11.667 11.666S2.334 20.434 2.334 14C2.334 7.567 7.567 2.333 14 2.333c6.433 0 11.667 5.234 11.667 11.667z", fill: "currentColor" }),
        React.createElement("path", { d: "M18.924 12.317a.871.871 0 01-.255.617l-4.049 4.068a.877.877 0 01-1.24 0l-4.05-4.068a.874.874 0 111.24-1.234L14 15.145l3.43-3.445a.875.875 0 011.494.617z", fill: "currentColor" })));
}

function SvgArrowDownSquare(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M2.333 9.235v9.53c0 4.128 2.656 6.901 6.61 6.901h10.114c3.954 0 6.61-2.773 6.61-6.901v-9.53c0-4.127-2.657-6.902-6.61-6.902H8.941c-3.953 0-6.609 2.775-6.609 6.902z", fill: "currentColor" }),
        React.createElement("path", { d: "M9.007 14.998l4.373 4.393c.329.33.911.33 1.241 0l4.373-4.393a.875.875 0 00-1.241-1.236l-2.879 2.89V9.238a.875.875 0 10-1.75 0v7.414l-2.877-2.89a.873.873 0 00-1.237-.002.876.876 0 00-.003 1.238z", fill: "currentColor" })));
}

function SvgArrowDown(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M12.611 9.57l-.381-4.316c0-.969.793-1.754 1.77-1.754.979 0 1.771.785 1.771 1.754L15.39 9.57c0 .76-.622 1.375-1.39 1.375-.768 0-1.389-.616-1.389-1.375z", fill: "currentColor" }),
        React.createElement("path", { d: "M12.681 24.062c-.068-.067-.355-.32-.595-.556-1.497-1.38-3.945-4.986-4.694-6.873-.12-.286-.374-1.01-.392-1.398 0-.37.086-.724.256-1.062a2.2 2.2 0 011.055-.943c.306-.118 1.225-.304 1.241-.304 1.004-.185 2.636-.285 4.44-.285 1.717 0 3.282.1 4.303.252.018.016 1.158.202 1.548.405A2.117 2.117 0 0121 15.168v.067c-.017.505-.46 1.566-.476 1.566-.749 1.786-3.079 5.306-4.627 6.722 0 0-.399.4-.647.572-.357.27-.799.405-1.241.405-.494 0-.952-.151-1.328-.438z", fill: "currentColor" })));
}

function SvgArrowDown6(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M12.678 8.417l4.923 7.99c.11.178.099.407-.03.575-.585.759-1.178 1.437-1.676 1.89 0 0-.399.39-.652.558-.345.272-.797.403-1.236.403-.492 0-.957-.143-1.33-.43-.066-.064-.36-.312-.598-.545-1.489-1.363-3.948-4.922-4.694-6.793-.12-.272-.371-1-.385-1.377 0-.363.08-.714.253-1.052.24-.415.61-.74 1.05-.922.306-.117 1.223-.298 1.25-.298.654-.118 1.574-.206 2.647-.249a.54.54 0 01.479.25z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M15.33 8.951c-.218-.352.06-.796.48-.778a27.83 27.83 0 012.491.204c.014.013 1.157.194 1.543.403A2.074 2.074 0 0121 10.624v.064c-.013.495-.451 1.547-.478 1.547-.22.53-.594 1.221-1.043 1.966a.536.536 0 01-.908.008L15.33 8.95z", fill: "currentColor" })));
}

function SvgArrowDown7(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M14.77 4.33v9.89a.83.83 0 01-1.659 0V4.33a.83.83 0 011.658 0z", fill: "currentColor" }),
        React.createElement("mask", { id: "Arrow-Down7_svg__a", maskUnits: "userSpaceOnUse", x: 7, y: 13, width: 14, height: 11 },
            React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M7.584 13.392h12.712V23.82H7.584v-10.43z", fill: "#fff" })),
        React.createElement("g", { mask: "url(#Arrow-Down7_svg__a)" },
            React.createElement("path", { d: "M20.296 14.22a.834.834 0 01-.127.443l-5.527 8.771a.831.831 0 01-1.404 0l-5.527-8.771a.827.827 0 01-.023-.843.826.826 0 01.725-.428h11.055a.826.826 0 01.828.829z", fill: "currentColor" }))));
}

function SvgArrowLeftCircle(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M14 25.667C7.566 25.667 2.333 20.433 2.333 14S7.566 2.334 14 2.334c6.433 0 11.667 5.233 11.667 11.666 0 6.433-5.234 11.667-11.667 11.667z", fill: "currentColor" }),
        React.createElement("path", { d: "M15.683 18.924a.871.871 0 01-.617-.255l-4.068-4.048a.877.877 0 010-1.24l4.068-4.051a.874.874 0 111.234 1.24L12.855 14l3.445 3.43a.875.875 0 01-.617 1.494z", fill: "currentColor" })));
}

function SvgArrowLeftRounded(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 32 32", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("circle", { opacity: 0.2, cx: 16, cy: 16, r: 16, fill: "currentColor" }),
        React.createElement("path", { d: "M8 16.128l-.707-.707-.707.707.707.707.707-.707zm15 1a1 1 0 100-2v2zm-9.707-7.713l-6 6.006 1.414 1.414 6-6.006-1.414-1.414zm-6 7.42l6 6.006 1.414-1.414-6-6.006-1.414 1.414zm.707.293h15v-2H8v2z", fill: "currentColor" })));
}

function SvgArrowLeftSquare(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M18.765 2.333h-9.53c-4.128 0-6.902 2.656-6.902 6.61v10.114c0 3.954 2.774 6.61 6.902 6.61h9.53c4.127 0 6.902-2.657 6.902-6.61V8.941c0-3.953-2.775-6.609-6.902-6.609z", fill: "currentColor" }),
        React.createElement("path", { d: "M13.002 9.007L8.61 13.38a.902.902 0 000 1.241l4.392 4.373a.875.875 0 001.236-1.241l-2.89-2.879h7.414a.875.875 0 100-1.75h-7.414l2.89-2.877a.873.873 0 00.002-1.237.876.876 0 00-1.238-.003z", fill: "currentColor" })));
}

function SvgArrowLeft(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M18.43 12.611l4.316-.381c.969 0 1.754.793 1.754 1.77 0 .979-.785 1.771-1.754 1.771l-4.316-.381c-.76 0-1.375-.622-1.375-1.39 0-.768.616-1.389 1.375-1.389z", fill: "currentColor" }),
        React.createElement("path", { d: "M3.938 12.681c.067-.068.32-.355.556-.595 1.38-1.497 4.986-3.945 6.873-4.694.286-.12 1.01-.374 1.398-.392.37 0 .724.086 1.062.256a2.2 2.2 0 01.943 1.055c.118.306.304 1.225.304 1.241.185 1.004.285 2.636.285 4.44 0 1.717-.1 3.282-.252 4.303-.016.018-.202 1.158-.405 1.548A2.117 2.117 0 0112.832 21h-.067c-.505-.017-1.566-.46-1.566-.476-1.786-.749-5.306-3.079-6.722-4.627 0 0-.4-.399-.572-.647-.27-.357-.405-.799-.405-1.241 0-.494.151-.952.438-1.328z", fill: "currentColor" })));
}

function SvgArrowLeft6(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M19.583 12.678l-7.99 4.923a.508.508 0 01-.575-.03c-.759-.585-1.437-1.178-1.89-1.676 0 0-.39-.399-.558-.652-.272-.345-.403-.797-.403-1.236 0-.492.143-.957.43-1.33.064-.066.312-.36.545-.598 1.363-1.489 4.922-3.948 6.793-4.694.272-.12 1-.371 1.377-.385.363 0 .714.08 1.052.253.415.24.74.61.922 1.05.117.306.298 1.223.298 1.25.118.654.206 1.574.249 2.647a.54.54 0 01-.25.479z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M19.049 15.33c.352-.219.796.06.778.48a27.844 27.844 0 01-.204 2.491c-.013.014-.195 1.157-.403 1.543A2.074 2.074 0 0117.376 21h-.064c-.495-.013-1.547-.451-1.547-.478-.53-.22-1.221-.594-1.966-1.043a.535.535 0 01-.008-.908l5.258-3.241z", fill: "currentColor" })));
}

function SvgArrowLeft7(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M23.67 14.77h-9.89a.83.83 0 010-1.659h9.89a.83.83 0 010 1.658z", fill: "currentColor" }),
        React.createElement("mask", { id: "Arrow-Left7_svg__a", maskUnits: "userSpaceOnUse", x: 4, y: 7, width: 11, height: 14 },
            React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M14.608 7.584v12.712H4.18V7.584h10.43z", fill: "#fff" })),
        React.createElement("g", { mask: "url(#Arrow-Left7_svg__a)" },
            React.createElement("path", { d: "M13.78 20.296a.834.834 0 01-.443-.127l-8.771-5.527a.831.831 0 010-1.404l8.771-5.527a.827.827 0 01.843-.023.826.826 0 01.428.725v11.055a.826.826 0 01-.829.828z", fill: "currentColor" }))));
}

function SvgArrowRightCircle(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M14 2.333c6.434 0 11.667 5.234 11.667 11.667S20.434 25.666 14 25.666C7.567 25.666 2.333 20.433 2.333 14 2.333 7.567 7.567 2.333 14 2.333z", fill: "currentColor" }),
        React.createElement("path", { d: "M12.317 9.076a.87.87 0 01.617.255l4.068 4.048a.877.877 0 010 1.24l-4.068 4.051a.874.874 0 11-1.234-1.24L15.145 14 11.7 10.57a.875.875 0 01.617-1.494z", fill: "currentColor" })));
}

function SvgArrowRightSquare(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M9.235 25.667h9.53c4.128 0 6.902-2.656 6.902-6.61V8.944c0-3.954-2.774-6.61-6.902-6.61h-9.53c-4.127 0-6.902 2.657-6.902 6.61v10.115c0 3.953 2.775 6.609 6.902 6.609z", fill: "currentColor" }),
        React.createElement("path", { d: "M14.998 18.993l4.393-4.373a.902.902 0 000-1.241l-4.393-4.373a.875.875 0 00-1.236 1.241l2.89 2.879H9.238a.875.875 0 100 1.75h7.414l-2.89 2.877a.873.873 0 00-.002 1.237.876.876 0 001.238.003z", fill: "currentColor" })));
}

function SvgArrowRight(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M9.57 15.389l-4.316.381A1.762 1.762 0 013.5 14c0-.979.785-1.771 1.754-1.771l4.316.381c.76 0 1.375.622 1.375 1.39 0 .768-.616 1.389-1.375 1.389z", fill: "currentColor" }),
        React.createElement("path", { d: "M24.062 15.319c-.067.068-.32.355-.556.595-1.38 1.497-4.986 3.945-6.873 4.694-.286.12-1.01.374-1.398.392-.37 0-.724-.086-1.062-.256a2.2 2.2 0 01-.943-1.055c-.118-.306-.304-1.224-.304-1.241-.185-1.004-.285-2.636-.285-4.44 0-1.717.1-3.282.252-4.303.016-.018.202-1.158.405-1.548A2.117 2.117 0 0115.168 7h.067c.505.017 1.566.46 1.566.475 1.786.75 5.306 3.08 6.722 4.628 0 0 .4.399.572.647.27.357.405.799.405 1.241 0 .494-.151.952-.438 1.328z", fill: "currentColor" })));
}

function SvgArrowRight7(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M4.33 13.23h9.89a.83.83 0 010 1.659H4.33a.83.83 0 010-1.658z", fill: "currentColor" }),
        React.createElement("mask", { id: "Arrow-Right7_svg__a", maskUnits: "userSpaceOnUse", x: 13, y: 7, width: 11, height: 14 },
            React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M13.392 20.416V7.704H23.82v12.712h-10.43z", fill: "#fff" })),
        React.createElement("g", { mask: "url(#Arrow-Right7_svg__a)" },
            React.createElement("path", { d: "M14.22 7.704c.155 0 .308.043.443.127l8.771 5.527a.831.831 0 010 1.404l-8.771 5.527a.827.827 0 01-.843.023.826.826 0 01-.428-.725V8.533a.826.826 0 01.829-.83z", fill: "currentColor" }))));
}

function SvgArrowUpCircle(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M2.333 14C2.333 7.566 7.567 2.333 14 2.333S25.666 7.566 25.666 14c0 6.433-5.233 11.667-11.666 11.667-6.433 0-11.667-5.234-11.667-11.667z", fill: "currentColor" }),
        React.createElement("path", { d: "M9.076 15.683c0-.223.085-.447.255-.617l4.049-4.068a.877.877 0 011.24 0l4.05 4.068a.874.874 0 11-1.24 1.234L14 12.855 10.57 16.3a.875.875 0 01-1.494-.617z", fill: "currentColor" })));
}

function SvgArrowUpSquare(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M25.667 18.765v-9.53c0-4.128-2.656-6.902-6.61-6.902H8.943c-3.953 0-6.609 2.773-6.609 6.902v9.53c0 4.127 2.657 6.902 6.61 6.902h10.115c3.953 0 6.609-2.775 6.609-6.902z", fill: "currentColor" }),
        React.createElement("path", { d: "M18.992 13.002L14.62 8.609a.902.902 0 00-1.241 0l-4.373 4.393a.875.875 0 001.241 1.235l2.878-2.89v7.415a.875.875 0 101.75 0v-7.414l2.877 2.89a.873.873 0 001.238.002.876.876 0 00.003-1.238z", fill: "currentColor" })));
}

function SvgArrowUp(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M15.389 18.43l.381 4.316c0 .969-.793 1.754-1.77 1.754-.979 0-1.771-.785-1.771-1.754l.381-4.316c0-.76.622-1.375 1.39-1.375.768 0 1.389.616 1.389 1.375z", fill: "currentColor" }),
        React.createElement("path", { d: "M15.319 3.938c.068.067.355.32.595.556 1.497 1.38 3.945 4.986 4.694 6.873.12.286.374 1.01.392 1.398 0 .37-.086.724-.256 1.062a2.2 2.2 0 01-1.055.943c-.306.118-1.224.304-1.241.304-1.004.185-2.636.285-4.44.285-1.717 0-3.282-.1-4.303-.252-.018-.016-1.158-.202-1.548-.405A2.117 2.117 0 017 12.832v-.067c.017-.505.46-1.566.475-1.566.75-1.786 3.08-5.306 4.628-6.722 0 0 .399-.4.647-.572.357-.27.799-.405 1.241-.405.494 0 .952.151 1.328.438z", fill: "currentColor" })));
}

function SvgArrowUp6(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M15.322 19.583l-4.923-7.99a.507.507 0 01.03-.575c.585-.759 1.178-1.437 1.676-1.89 0 0 .399-.39.652-.558.345-.272.797-.403 1.236-.403.492 0 .957.143 1.33.43.066.064.36.312.598.545 1.489 1.363 3.948 4.922 4.694 6.793.12.272.371 1 .385 1.377 0 .363-.08.714-.253 1.052-.24.415-.61.74-1.05.922-.306.117-1.223.298-1.25.298-.654.118-1.574.206-2.647.249a.54.54 0 01-.479-.25z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M12.67 19.049c.218.352-.06.796-.48.778a27.84 27.84 0 01-2.491-.204c-.014-.013-1.157-.195-1.543-.403A2.074 2.074 0 017 17.376v-.064c.013-.495.452-1.547.478-1.547.22-.53.594-1.221 1.043-1.966a.536.536 0 01.908-.008l3.241 5.258z", fill: "currentColor" })));
}

function SvgArrowUp7(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M13.23 23.67v-9.89a.83.83 0 011.659 0v9.89a.83.83 0 01-1.658 0z", fill: "currentColor" }),
        React.createElement("mask", { id: "Arrow-Up7_svg__a", maskUnits: "userSpaceOnUse", x: 7, y: 4, width: 14, height: 11 },
            React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M20.416 14.608H7.704V4.18h12.712v10.43z", fill: "#fff" })),
        React.createElement("g", { mask: "url(#Arrow-Up7_svg__a)" },
            React.createElement("path", { d: "M7.704 13.78c0-.155.043-.308.127-.443l5.527-8.771a.831.831 0 011.404 0l5.527 8.771c.16.256.17.578.023.843a.826.826 0 01-.725.428H8.533a.826.826 0 01-.83-.829z", fill: "currentColor" }))));
}

function SvgArrow(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 9 21", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("g", { opacity: 0.6, clipPath: "url(#Arrow_svg__clip0)" },
            React.createElement("path", { fill: "#fff", fillOpacity: 0.01, d: "M.914.535h8v20h-8z" }),
            React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M1.206 8.828a1.009 1.009 0 000 1.419l2.939 2.965c.218.215.5.322.779.322s.556-.107.769-.322l2.93-2.955A1.01 1.01 0 008.3 8.62a.987.987 0 00-1.084.218l-2.298 2.317-2.307-2.327a.99.99 0 00-1.406 0z", fill: "currentColor" })),
        React.createElement("defs", null,
            React.createElement("clipPath", { id: "Arrow_svg__clip0" },
                React.createElement("path", { fill: "#fff", transform: "translate(.914 .535)", d: "M0 0h8v20H0z" })))));
}

function SvgAward(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 25 24", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M19.209 14.694A8.237 8.237 0 0112.604 18a8.237 8.237 0 01-6.605-3.306l-2.302 3.988a1 1 0 001.053 1.482l1.873-.355a1 1 0 011.13.653l.63 1.8a1 1 0 001.81.17l2.41-4.177 2.413 4.177a1 1 0 001.81-.17l.628-1.8a1 1 0 011.13-.653l1.874.355a1 1 0 001.053-1.482l-2.302-3.987z", fill: "currentColor" }),
        React.createElement("circle", { cx: 12.604, cy: 9.75, r: 7.25, stroke: "currentColor", strokeWidth: 2 })));
}

function SvgBag(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M3.601 19.034l.897-7.227c.547-2.58 2.093-3.64 3.568-3.64h11.847c1.495 0 3.093.987 3.557 3.64l.908 7.227c.742 5.306-1.99 6.633-5.558 6.633H9.148c-3.557 0-6.207-1.921-5.547-6.633zm13.786-4.86c.57 0 1.03-.476 1.03-1.062 0-.586-.46-1.061-1.03-1.061-.57 0-1.031.475-1.031 1.061s.461 1.061 1.03 1.061zm-5.723-1.062c0 .586-.461 1.061-1.03 1.061-.57 0-1.032-.475-1.032-1.06 0-.587.462-1.062 1.031-1.062.57 0 1.031.475 1.031 1.061z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M8.197 7.903c-.004.09.014.181.051.264h1.677a.757.757 0 00.05-.264c0-2.237 1.82-4.05 4.065-4.05a4.058 4.058 0 014.065 4.05.756.756 0 000 .264h1.717a.756.756 0 000-.264c-.13-3.113-2.701-5.57-5.828-5.57-3.126 0-5.697 2.457-5.827 5.57h.03z", fill: "currentColor" })));
}

function SvgBag4(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M19.39 25.667H8.61c-3.14 0-5.693-2.53-5.693-5.642v-6.217c0-3.11 2.554-5.641 5.692-5.641H19.39c3.14 0 5.693 2.53 5.693 5.641v6.217c0 3.111-2.554 5.642-5.693 5.642z", fill: "currentColor" }),
        React.createElement("path", { d: "M18.38 11.667a.857.857 0 01-.868-.843V7.416c0-1.873-1.571-3.397-3.502-3.397-.889 0-1.821.346-2.485.983a3.321 3.321 0 00-1.037 2.399v3.423c0 .465-.39.843-.87.843a.857.857 0 01-.868-.843V7.416a4.981 4.981 0 011.551-3.61c.993-.956 2.277-1.436 3.713-1.473 2.885 0 5.236 2.28 5.236 5.083v3.408c0 .465-.39.843-.87.843z", fill: "currentColor" })));
}

function SvgBookmark(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M13.99 21.725l-7.574 3.783a1.19 1.19 0 01-1.605-.466 1.272 1.272 0 01-.144-.58v-8.468c0 .84.473 1.357 1.718 1.938l7.604 3.793z", fill: "currentColor" }),
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M10.378 2.333h7.203c3.159 0 5.721 1.244 5.752 4.426V24.46a1.23 1.23 0 01-.144.57 1.176 1.176 0 01-1.636.477l-7.564-3.783-7.604-3.793c-1.245-.58-1.718-1.099-1.718-1.938V6.759c0-3.182 2.562-4.426 5.71-4.426zm-.782 8.893h8.777a.92.92 0 00.916-.923.92.92 0 00-.916-.922H9.596a.92.92 0 00-.916.922c0 .51.41.923.916.923z", fill: "currentColor" })));
}

function SvgBookmark1(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 25 24", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.3, d: "M5.104 6.25a4 4 0 014-4h7a4 4 0 014 4v13.58a1 1 0 01-1.574.819L12.604 16.5l-5.927 4.149a1 1 0 01-1.573-.82V6.25z", fill: "currentColor" }),
        React.createElement("path", { d: "M6.104 6.25a3 3 0 013-3h7a3 3 0 013 3v13.58l-5.353-3.748a2 2 0 00-2.294 0L6.104 19.83V6.25z", stroke: "currentColor", strokeWidth: 2 })));
}

function SvgBuy(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, fillRule: "evenodd", clipRule: "evenodd", d: "M6.896 24.603c0-.98.793-1.773 1.773-1.773a1.768 1.768 0 11-1.773 1.773zm13.124 0c0-.98.794-1.773 1.774-1.773a1.768 1.768 0 11-1.773 1.773z", fill: "currentColor" }),
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M23.556 7.99c.712 0 1.178.245 1.645.782.467.537.548 1.307.443 2.006l-1.108 7.653a2.977 2.977 0 01-2.952 2.555H8.856a2.974 2.974 0 01-2.963-2.729L4.819 5.54l-1.761-.303a.878.878 0 01-.712-1.003.892.892 0 011.015-.724l2.783.42a.88.88 0 01.723.794l.222 2.613a.712.712 0 00.711.654h15.756zm-7.07 6.066h3.232c.49 0 .875-.397.875-.875a.867.867 0 00-.875-.875h-3.232a.867.867 0 00-.875.875c0 .478.385.875.875.875z", fill: "currentColor" })));
}

function SvgCalendar(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, fillRule: "evenodd", clipRule: "evenodd", d: "M10.438 5.928h7.167V4.26h-7.167v1.668zm-1.63-1.6v.009a8.02 8.02 0 00-1.651.329V4.66a.704.704 0 01-.046.017.432.432 0 00-.054.021.604.604 0 00-.126.046 4.48 4.48 0 00-.435.168 1.85 1.85 0 01-.089.038c-.04.02-.083.04-.125.062-.042.02-.085.042-.125.06l-.2.116c-.037.019-.071.041-.106.064l-.064.04c-.302.194-.58.422-.833.68l-.015.016-.099.113a6.273 6.273 0 00-.16.186l-.014.014a6.181 6.181 0 00-1.158 3.933v.448h1.616v-.452c0-1.966.627-3.19 2.02-3.818a5.533 5.533 0 011.668-.415h.015V4.336l-.02-.008zM23.33 6.28l.007.015a6.186 6.186 0 011.154 3.935v.452h-1.615v-.463a5.147 5.147 0 00-.488-2.41A3.072 3.072 0 0020.847 6.4a5.34 5.34 0 00-1.643-.415V4.333c.56.051 1.113.162 1.652.329v-.009c.03.014.053.022.093.036l.007.003c.019.006.036.013.053.02l.072.026c.11.036.214.079.32.123l.02.007c.049.018.095.039.137.058l.039.018a3.7 3.7 0 01.389.2l.068.038c.036.02.067.04.097.061.022.015.043.03.065.043.302.195.585.423.84.68l.009.015c.094.095.183.195.266.3z", fill: "currentColor" }),
        React.createElement("path", { d: "M19.25 3.17v3.677a.839.839 0 01-1.68 0V3.178a.839.839 0 011.68-.013v.005zM10.43 3.183v3.668a.84.84 0 11-1.68 0V3.183a.84.84 0 111.68 0z", fill: "currentColor" }),
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M3.5 19.729v-9.047h21v9.046c0 3.945-2.203 5.939-6.57 5.939h-7.87c-4.357 0-6.56-1.994-6.56-5.939zm4.737-4.018c0 .548.43.992.961.992.54 0 .971-.455.961-1.002 0-.547-.43-.992-.95-.992h-.01c-.532 0-.962.455-.962 1.002zm4.797 0c0 .548.44.992.971.992.53 0 .961-.444.961-1.002a.99.99 0 00-.961-.992h-.01a.993.993 0 00-.961 1.002zm5.768.992c-.53 0-.962-.444-.962-.992 0-.547.421-.991.962-.991.53 0 .961.444.961.991 0 .548-.43.992-.961.992zm0 4.234c-.53 0-.962-.444-.971-.992 0-.547.43-.991.96-.991h.01c.532 0 .962.444.962.991 0 .548-.43.992-.961.992zm-4.797 0a.985.985 0 01-.971-.992c0-.547.43-.991.961-1.001h.01c.53.01.951.454.961.991 0 .558-.43 1.002-.961 1.002zm-4.807 0c-.53 0-.961-.444-.961-.992a.973.973 0 01.961-1.001c.53 0 .961.444.961.991 0 .547-.43 1.002-.96 1.002z", fill: "currentColor" })));
}

function SvgCalendar1(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 24 24", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M17 12h-5v5h5v-5zM16 1v2H8V1H6v2H5c-1.11 0-1.99.9-1.99 2L3 19a2 2 0 002 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2h-1V1h-2zm3 18H5V8h14v11z", fill: "currentColor" })));
}

function SvgCallMissed(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M24.965 19.477c-.648-.663-3.45-2.892-4.146-3.036-.774-.165-1.386.192-1.928.503-.557.322-1.036.598-1.64.379-3.099-1.265-5.312-3.476-6.572-6.563-.223-.614.054-1.094.375-1.652.311-.54.662-1.152.503-1.926-.145-.696-2.373-3.498-3.037-4.146-.439-.427-.887-.662-1.345-.7-1.73-.074-3.869 2.418-4.208 2.967-.85 1.169-.844 2.723.015 4.608 2.068 5.063 9.973 12.969 15.096 15.098.944.438 1.808.658 2.585.658.76 0 1.436-.21 2.017-.628.438-.25 3.048-2.465 2.985-4.228-.037-.45-.273-.898-.7-1.334z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M22.528 6.708l2.882-2.882a.876.876 0 00-1.238-1.237L21.29 5.47l-2.881-2.88a.876.876 0 00-1.239 1.236l2.883 2.882L17.17 9.59a.874.874 0 101.239 1.236l2.88-2.88 2.883 2.88a.871.871 0 001.238 0 .874.874 0 000-1.236l-2.882-2.882z", fill: "currentColor" })));
}

function SvgCallSilent(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M8.048 16.74l3.967-4.006a11.99 11.99 0 01-1.342-2.476c-.217-.6.048-1.076.356-1.628l.018-.032c.314-.542.664-1.167.513-1.944-.152-.708-2.38-3.536-3.045-4.196-.432-.424-.887-.66-1.342-.707-1.727-.07-3.862 2.451-4.2 3.004-.852 1.179-.852 2.747.011 4.644.864 2.168 2.766 4.832 5.064 7.34zm14.631 7.942c.432-.247 3.045-2.485 2.987-4.266-.047-.46-.28-.907-.7-1.343-.654-.672-3.454-2.922-4.154-3.075-.756-.163-1.367.187-1.897.491l-.028.016-.006.004c-.557.327-1.034.607-1.639.385a12.494 12.494 0 01-2.812-1.614l-3.92 3.958c2.567 2.44 5.332 4.49 7.56 5.422.945.436 1.809.659 2.59.659.759 0 1.436-.213 2.019-.637z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M25.409 4.19l-10.98 11.09-3.92 3.959-6.685 6.752a.912.912 0 01-.618.259.912.912 0 01-.618-.26.885.885 0 01-.035-1.202c.011-.023.023-.035.035-.047l6.662-6.73 3.873-3.91h.012l10.64-10.747c.024-.024.047-.047.059-.072l.338-.342a.856.856 0 011.237 0 .897.897 0 010 1.25z", fill: "currentColor" })));
}

function SvgCall(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M22.688 25.04c-.578.413-1.255.627-2.015.627-.776 0-1.643-.223-2.585-.651C12.961 22.878 5.05 14.975 2.985 9.909c-.866-1.89-.866-3.44-.016-4.603.199-.315.974-1.27 1.933-1.997.04.289 5.697 7.194 5.697 7.078.008.125.033.248.082.38 1.264 3.077 3.477 5.288 6.582 6.559.123.042.23.065.346.065l.009.01c.264.313 6.985 5.807 7.077 5.684-.76 1.007-1.751 1.814-2.007 1.955z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M10.6 10.38c-.024-.444.201-.835.453-1.272.311-.54.664-1.153.504-1.926-.146-.697-2.375-3.498-3.04-4.147-.438-.426-.886-.661-1.346-.7-.74-.033-1.557.407-2.274.963-.12.093 5.708 7.204 5.702 7.083zM17.611 17.387c.445.022.836-.203 1.273-.454.54-.31 1.155-.664 1.93-.503.696.146 3.5 2.373 4.15 3.036.427.438.662.886.701 1.345.03.74-.408 1.557-.964 2.273-.094.12-7.211-5.704-7.09-5.697z", fill: "currentColor" })));
}

function SvgCalling(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M20.472 16.611c-.76-.162-1.36.189-1.892.495-.545.313-1.016.586-1.609.37-3.041-1.24-5.213-3.412-6.45-6.44-.217-.602.054-1.075.368-1.622.306-.53.652-1.133.495-1.891-.143-.683-2.33-3.433-2.98-4.07-.43-.418-.87-.65-1.32-.688-1.698-.071-3.797 2.375-4.13 2.913-.833 1.147-.827 2.673.015 4.523 2.029 4.97 9.787 12.73 14.813 14.82.927.431 1.776.646 2.538.646.746 0 1.409-.207 1.98-.618.43-.244 2.99-2.418 2.929-4.148-.037-.441-.268-.882-.687-1.31-.637-.651-3.387-2.838-4.07-2.98z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M19.903 11.42a.858.858 0 101.686-.328 5.905 5.905 0 00-4.686-4.685.869.869 0 00-1.008.68.86.86 0 00.68 1.006 4.194 4.194 0 013.328 3.327z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M16.834 2.34a.852.852 0 00-.948.758.859.859 0 00.758.949 8.224 8.224 0 017.304 7.296.86.86 0 001.707-.193 9.933 9.933 0 00-8.821-8.81z", fill: "currentColor" })));
}

function SvgCamera(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M19.495 11.75c0 .584.467 1.05 1.05 1.05s1.062-.466 1.062-1.05c0-.582-.479-1.06-1.062-1.06-.583 0-1.05.478-1.05 1.06zm-2.263 7.04A4.562 4.562 0 0114 20.13a4.575 4.575 0 01-4.585-4.58c-.011-1.212.467-2.354 1.33-3.228A4.575 4.575 0 0114 10.97c1.225 0 2.38.478 3.244 1.34a4.596 4.596 0 011.341 3.24 4.617 4.617 0 01-1.353 3.24zM14 12.718c-.758 0-1.47.291-2.018.84a2.737 2.737 0 00-.817 1.98v.012c0 .757.292 1.468.829 2.004a2.816 2.816 0 002.006.828 2.844 2.844 0 002.835-2.832 2.81 2.81 0 00-.828-2.005A2.816 2.816 0 0014 12.719z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M20.347 7.276l-.117-.257c-.315-.664-.677-1.433-.898-1.876-.537-1.049-1.459-1.631-2.59-1.643h-5.495c-1.132.012-2.042.594-2.579 1.643-.233.466-.63 1.305-.956 1.993l-.07.14c-.035.093-.129.14-.222.14a5.088 5.088 0 00-5.087 5.08v6.923A5.088 5.088 0 007.42 24.5h13.16c2.8 0 5.087-2.284 5.087-5.081v-6.922c0-2.797-2.287-5.081-5.087-5.081a.266.266 0 01-.233-.14z", fill: "currentColor" })));
}

function SvgCategory(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M18.755 2.333h3.95c1.636 0 2.962 1.337 2.962 2.987v3.984c0 1.65-1.326 2.986-2.962 2.986h-3.95c-1.636 0-2.962-1.337-2.962-2.986V5.32c0-1.65 1.326-2.987 2.962-2.987z", fill: "currentColor" }),
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M5.295 2.333h3.95c1.636 0 2.962 1.337 2.962 2.987v3.984c0 1.65-1.326 2.986-2.962 2.986h-3.95c-1.636 0-2.962-1.337-2.962-2.986V5.32c0-1.65 1.326-2.987 2.962-2.987zm0 13.377h3.95c1.636 0 2.962 1.337 2.962 2.986v3.984c0 1.649-1.326 2.987-2.962 2.987h-3.95c-1.636 0-2.962-1.338-2.962-2.987v-3.984c0-1.65 1.326-2.986 2.962-2.986zm17.41 0h-3.95c-1.636 0-2.962 1.337-2.962 2.986v3.984c0 1.649 1.326 2.987 2.962 2.987h3.95c1.636 0 2.962-1.338 2.962-2.987v-3.984c0-1.65-1.326-2.986-2.962-2.986z", fill: "currentColor" })));
}

function SvgChart(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M19.455 2.333h-10.9c-3.971 0-6.221 2.25-6.221 6.223v10.888c0 3.972 2.25 6.223 6.222 6.223h10.899c3.972 0 6.212-2.25 6.212-6.223V8.556c0-3.972-2.24-6.223-6.212-6.223z", fill: "currentColor" }),
        React.createElement("path", { d: "M10.94 19.403c0 .53.436.965.975.965h8.017a.97.97 0 000-1.94h-8.017a.974.974 0 00-.974.975zM7.114 13.958c0 .53.435.965.975.965h11.843a.97.97 0 000-1.94H8.089a.974.974 0 00-.975.975zM15.172 8.587c0 .539.435.975.975.975h3.785a.97.97 0 000-1.94h-3.785a.971.971 0 00-.975.965z", fill: "currentColor" })));
}

function SvgChat(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M14.024 2.333c-6.779 0-11.69 5.53-11.69 11.667 0 1.96.571 3.978 1.575 5.822.186.303.21.688.081 1.05l-.782 2.613c-.175.63.362 1.097.957.91l2.357-.7c.641-.21 1.143.058 1.74.42 1.703 1.003 3.825 1.517 5.738 1.517 5.787 0 11.667-4.469 11.667-11.667 0-6.207-5.017-11.632-11.644-11.632z", fill: "currentColor" }),
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M13.977 15.505A1.506 1.506 0 0112.484 14c0-.817.677-1.493 1.493-1.482.829 0 1.494.665 1.494 1.494 0 .816-.665 1.493-1.494 1.493zm-5.378 0a1.504 1.504 0 01-1.494-1.493c0-.829.665-1.494 1.494-1.494.828 0 1.493.665 1.493 1.494 0 .816-.665 1.481-1.493 1.493zm9.263-1.493c0 .816.665 1.493 1.494 1.493.828 0 1.493-.677 1.493-1.493 0-.829-.665-1.494-1.493-1.494-.829 0-1.494.665-1.494 1.494z", fill: "currentColor" })));
}

function SvgCheckRoundedOutline(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 40 40", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M27.65 12.633L16.667 23.617l-5.984-5.967L8.334 20l8.334 8.333L30 15l-2.35-2.367zM20 3.333C10.8 3.333 3.334 10.8 3.334 20c0 9.2 7.466 16.667 16.666 16.667S36.667 29.2 36.667 20C36.667 10.8 29.2 3.333 20 3.333zm0 30c-7.367 0-13.333-5.966-13.333-13.333S12.633 6.667 20 6.667 33.334 12.633 33.334 20 27.367 33.333 20 33.333z", fill: "currentColor" })));
}

function SvgCloseSquare(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M19.063 2.333H8.948c-3.955 0-6.615 2.777-6.615 6.907v9.531c0 4.119 2.66 6.895 6.615 6.895h10.115c3.955 0 6.603-2.776 6.603-6.895V9.24c0-4.13-2.648-6.907-6.603-6.907z", fill: "currentColor" }),
        React.createElement("path", { d: "M17.518 16.065l-2.075-2.074 2.074-2.074a1.02 1.02 0 000-1.444 1.018 1.018 0 00-1.443 0l-2.076 2.074-2.075-2.077a1.023 1.023 0 00-1.444 0 1.023 1.023 0 000 1.444l2.076 2.077-2.072 2.07a1.02 1.02 0 00.721 1.744c.263 0 .523-.1.722-.299l2.072-2.072 2.077 2.076a1.022 1.022 0 001.443-1.444z", fill: "currentColor" })));
}

function SvgComment(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 18 18", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M15.75 4.5h-1.5v6.75H4.5v1.5c0 .412.338.75.75.75h8.25l3 3V5.25a.752.752 0 00-.75-.75zm-3 4.5V2.25A.752.752 0 0012 1.5H2.25a.752.752 0 00-.75.75v10.5l3-3H12c.412 0 .75-.338.75-.75z", fill: "currentColor" })));
}

function SvgDanger(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M5.51 24.695l-.046-.001a3.305 3.305 0 01-2.889-4.538l8.542-14.964c.294-.532.74-.978 1.283-1.279a3.305 3.305 0 014.487 1.29l8.485 14.849c.19.444.27.806.29 1.175a3.28 3.28 0 01-.846 2.382 3.276 3.276 0 01-2.282 1.085l-16.94.001H5.51z", fill: "currentColor" }),
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M12.979 11.69c0-.561.458-1.02 1.02-1.02.563 0 1.021.459 1.021 1.02v3.3a1.022 1.022 0 01-2.041 0v-3.3zm0 7.292c0-.566.458-1.027 1.02-1.027.563 0 1.021.455 1.021 1.014 0 .575-.458 1.033-1.02 1.033-.563 0-1.021-.458-1.021-1.02z", fill: "currentColor" })));
}

function SvgDelete(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M22.917 11.07c0 .08-.622 7.943-.977 11.253-.222 2.031-1.532 3.263-3.496 3.298-1.509.034-2.986.046-4.44.046-1.543 0-3.052-.012-4.516-.046-1.899-.045-3.21-1.302-3.42-3.298-.366-3.321-.976-11.174-.987-11.253a.926.926 0 01.222-.651.828.828 0 01.61-.273h16.183c.232 0 .443.102.61.273a.873.873 0 01.211.65z", fill: "currentColor" }),
        React.createElement("path", { d: "M24.5 6.973a.843.843 0 00-.832-.855h-3.401a1.495 1.495 0 01-1.448-1.187l-.19-.85c-.267-1.028-1.188-1.748-2.22-1.748h-4.817c-1.044 0-1.955.72-2.232 1.804l-.178.796a1.497 1.497 0 01-1.448 1.185H4.333a.843.843 0 00-.833.855v.443c0 .468.378.855.833.855h19.335c.454 0 .832-.387.832-.855v-.443z", fill: "currentColor" })));
}

function SvgDisableIcon(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 40 40", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M20 3.333c-9.166 0-16.666 7.5-16.666 16.667 0 9.167 7.5 16.667 16.666 16.667 9.167 0 16.667-7.5 16.667-16.667 0-9.167-7.5-16.667-16.667-16.667zM6.667 20c0-7.333 6-13.333 13.333-13.333 3 0 5.834 1 8.167 2.833L9.5 28.167A13.135 13.135 0 016.667 20zM20 33.333c-3 0-5.833-1-8.166-2.833L30.5 11.833A13.135 13.135 0 0133.334 20c0 7.333-6 13.333-13.334 13.333z", fill: "currentColor" })));
}

function SvgDiscount(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M13.999 25.665c-.897 0-1.793-.341-2.478-1.021l-.852-.852a1.755 1.755 0 00-1.241-.512H8.23a3.517 3.517 0 01-3.513-3.513v-1.2a1.76 1.76 0 00-.514-1.242l-.837-.836a3.517 3.517 0 01-.013-4.967l.852-.853c.329-.33.51-.772.512-1.24V8.23A3.517 3.517 0 018.23 4.717h1.199c.468 0 .909-.182 1.241-.514l.84-.837a3.516 3.516 0 014.966-.013l.851.852c.332.33.773.512 1.24.512h1.2a3.517 3.517 0 013.513 3.514V9.43c0 .468.183.91.513 1.243l.838.837a3.49 3.49 0 011.035 2.48 3.491 3.491 0 01-1.012 2.475c-.012.012-.022.025-.034.035l-.828.829c-.33.33-.511.772-.512 1.24v1.2a3.517 3.517 0 01-3.513 3.512h-1.2c-.467.001-.91.183-1.24.513l-.84.838A3.499 3.499 0 0114 25.665z", fill: "currentColor" }),
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M11.717 11.726a.999.999 0 01-.72.296c-.258 0-.512-.106-.717-.297a1.027 1.027 0 01-.303-.723c0-.255.107-.516.296-.718a.924.924 0 01.352-.226c.352-.161.82-.067 1.097.225a.973.973 0 01.308.719.98.98 0 01-.313.724zm6.004-1.448a1.024 1.024 0 00-1.443 0l-5.997 5.997a1.023 1.023 0 00.723 1.743c.273 0 .528-.107.72-.299l5.997-5.997a1.023 1.023 0 000-1.444zm-.331 5.78a1.032 1.032 0 00-1.125.226c-.062.073-.149.185-.209.316a.991.991 0 00-.07.398c0 .103.007.255.07.397.059.13.129.237.221.329.211.196.456.295.73.295.258 0 .512-.105.721-.3.186-.185.287-.442.287-.72 0-.28-.101-.536-.288-.723a.93.93 0 00-.337-.218z", fill: "currentColor" })));
}

function SvgDiscovery(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M25.666 14c0 6.443-5.223 11.666-11.666 11.666-6.444 0-11.667-5.223-11.667-11.666C2.333 7.558 7.556 2.333 14 2.333c6.443 0 11.666 5.225 11.666 11.667z", fill: "currentColor" }),
        React.createElement("path", { d: "M18.503 10.156l-1.89 5.973a.76.76 0 01-.514.515l-5.95 1.865a.522.522 0 01-.653-.653l1.867-5.985a.779.779 0 01.513-.514l5.973-1.866a.524.524 0 01.654.665z", fill: "currentColor" })));
}

function SvgDocument(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M18.89 2.333H9.112C5.565 2.333 3.5 4.41 3.5 7.968V20.02c0 3.617 2.065 5.647 5.612 5.647h9.778c3.603 0 5.61-2.03 5.61-5.647V7.968c0-3.558-2.007-5.635-5.61-5.635z", fill: "currentColor" }),
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M9.427 7.758v.012a.91.91 0 000 1.82h3.487a.914.914 0 00.911-.923c0-.5-.408-.909-.911-.909H9.427zm9.146 7.105H9.427a.91.91 0 010-1.82h9.146a.911.911 0 010 1.821zm0 5.332H9.427a.906.906 0 01-.875-.42.927.927 0 01.875-1.412h9.146a.915.915 0 01.817.922.913.913 0 01-.817.91z", fill: "currentColor" })));
}

function SvgDocx(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 32 32", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M7.548 29h16.687c.855 0 1.548-.693 1.548-1.547V8.483l-3.018-2.513L19.23 3H7.548C6.693 3 6 3.693 6 4.548v22.904C6 28.308 6.693 29 7.548 29z", fill: "currentColor" }),
        React.createElement("path", { d: "M11.514 16.994c0 .391-.085.74-.255 1.045a1.744 1.744 0 01-.723.707c-.313.17-.682.254-1.108.254h-1.51v-3.996h1.51c.43 0 .8.083 1.113.249.313.165.552.399.718.7.17.302.255.649.255 1.04zm-2.171 1.141c.377 0 .669-.1.876-.3.211-.2.317-.48.317-.841 0-.362-.106-.643-.317-.843-.207-.2-.5-.3-.876-.3h-.458v2.284h.458zm4.62-3.193c.377 0 .718.088 1.023.265.31.174.552.417.73.73.176.309.265.659.265 1.05 0 .393-.09.745-.271 1.058-.178.313-.42.557-.73.735-.305.173-.644.26-1.017.26-.373 0-.714-.087-1.023-.26a1.978 1.978 0 01-.73-.735 2.107 2.107 0 01-.265-1.057c0-.392.089-.742.266-1.051.18-.313.424-.556.73-.73a2.02 2.02 0 011.022-.265zm0 .898c-.316 0-.569.104-.757.311-.185.204-.277.483-.277.837 0 .35.092.63.277.836.188.208.44.311.757.311.313 0 .564-.103.752-.31.188-.208.283-.487.283-.837s-.095-.63-.283-.837c-.185-.207-.435-.31-.752-.31zm4.387-.876c.508 0 .928.134 1.26.402.335.267.552.629.65 1.085h-1.023a.932.932 0 00-.904-.594.848.848 0 00-.684.311c-.174.207-.26.485-.26.831 0 .347.086.624.26.831a.855.855 0 00.684.305.937.937 0 00.904-.588h1.023a1.853 1.853 0 01-.65 1.086c-.332.267-.752.4-1.26.4-.389 0-.73-.084-1.024-.253a1.783 1.783 0 01-.683-.724A2.285 2.285 0 0116.405 17c0-.395.08-.748.238-1.057.162-.309.39-.548.683-.718.294-.173.635-.26 1.024-.26zM23.227 19l-.843-1.244L21.661 19h-1.108l1.277-2.057-1.317-1.94h1.148l.82 1.205.706-1.204h1.102l-1.26 2.012L24.374 19h-1.147z", fill: "#fff" }),
        React.createElement("path", { d: "M19.225 6.985L19.206 3l6.526 5.545-4.966-.02a1.547 1.547 0 01-1.541-1.54z", fill: "currentColor" })));
}

function SvgDone(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 16 16", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M3.333 9.333l1.9 1.425a1 1 0 001.374-.167L12 4", stroke: "currentColor", strokeWidth: 2, strokeLinecap: "round" })));
}

function SvgDownload(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M20.48 8.512c2.86 0 5.187 2.403 5.187 5.357v5.87c0 2.947-2.322 5.344-5.176 5.344H7.523c-2.86 0-5.19-2.402-5.19-5.355v-5.871c0-2.946 2.323-5.345 5.178-5.345H20.48z", fill: "currentColor" }),
        React.createElement("path", { d: "M14.637 18.71l3.394-3.462a.922.922 0 00-.002-1.29.89.89 0 00-1.27.002l-1.86 1.896V3.829A.906.906 0 0014 2.917a.905.905 0 00-.897.912v12.027l-1.86-1.896a.89.89 0 00-1.27-.003.92.92 0 00-.002 1.29l3.394 3.463c.169.172.397.27.635.27.24 0 .468-.098.637-.27z", fill: "currentColor" })));
}

function SvgDownload1(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 24 24", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M19 9h-4V3H9v6H5l7 7 7-7zM5 18v2h14v-2H5z", fill: "currentColor" })));
}

function SvgEditSquare(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M19.442 25.655H8.558a6.233 6.233 0 01-4.592-1.62 6.237 6.237 0 01-1.62-4.592V8.557a6.236 6.236 0 011.618-4.592 6.238 6.238 0 014.594-1.62h10.884a6.228 6.228 0 014.588 1.62 6.267 6.267 0 011.625 4.592v10.886a6.241 6.241 0 01-1.62 4.592 6.238 6.238 0 01-4.593 1.62z", fill: "currentColor" }),
        React.createElement("path", { d: "M19.897 12.13l-7.645 7.683a2.1 2.1 0 01-1.465.604h-2.67a.54.54 0 01-.386-.16.533.533 0 01-.147-.387l.068-2.697a2.052 2.052 0 01.602-1.412l5.418-5.429a.247.247 0 01.34 0l1.901 1.893a.718.718 0 00.5.205.75.75 0 00.75-.751.772.772 0 00-.205-.524 281.066 281.066 0 00-1.843-1.847.303.303 0 010-.421l.76-.774a1.794 1.794 0 012.545 0l1.477 1.48a1.81 1.81 0 010 2.537z", fill: "currentColor" })));
}

function SvgEdit(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M23.601 21.672H15.86a.894.894 0 00-.9.889c0 .49.404.889.9.889H23.6a.894.894 0 00.899-.89c0-.49-.403-.888-.899-.888z", fill: "currentColor" }),
        React.createElement("path", { d: "M19.686 13.65l-8.875 8.77c-.607.6-1.43.94-2.289.94H4.336a.893.893 0 01-.602-.245.862.862 0 01-.234-.606l.111-4.169a3.157 3.157 0 01.948-2.195l8.83-8.735a.379.379 0 01.53 0l5.767 5.717a.367.367 0 010 .524z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M22.802 10.526l-1.206 1.204a.468.468 0 01-.658.002l-5.629-5.57a.457.457 0 010-.65l1.193-1.19a2.829 2.829 0 013.978-.008l2.315 2.29a2.758 2.758 0 01.007 3.922z", fill: "currentColor" })));
}

function SvgExpand(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 24 38", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M16.59 15L12 19.58 7.41 15 6 16.41l6 6 6-6L16.59 15z", fill: "currentColor" })));
}

function SvgEyeRounded(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 32 32", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("circle", { opacity: 0.2, cx: 16, cy: 16, r: 16, fill: "currentColor" }),
        React.createElement("path", { d: "M16 8.5c-5 0-9.27 3.11-11 7.5 1.73 4.39 6 7.5 11 7.5s9.27-3.11 11-7.5c-1.73-4.39-6-7.5-11-7.5zM16 21c-2.76 0-5-2.24-5-5s2.24-5 5-5 5 2.24 5 5-2.24 5-5 5zm0-8c-1.66 0-3 1.34-3 3s1.34 3 3 3 3-1.34 3-3-1.34-3-3-3z", fill: "currentColor" })));
}

function SvgFilter(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M21.254 16.173c-2.437 0-4.414 1.994-4.414 4.455 0 2.46 1.977 4.455 4.414 4.455 2.437 0 4.412-1.995 4.412-4.455s-1.975-4.455-4.412-4.455z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M11.764 18.854H4.093c-.971 0-1.76.795-1.76 1.774s.789 1.776 1.76 1.776h7.671c.97 0 1.758-.797 1.758-1.776s-.788-1.774-1.758-1.774z", fill: "currentColor" }),
        React.createElement("path", { d: "M6.747 11.827c2.437 0 4.414-1.994 4.414-4.454 0-2.461-1.977-4.456-4.414-4.456-2.437 0-4.413 1.995-4.413 4.456 0 2.46 1.976 4.454 4.413 4.454z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M25.667 7.373c0-.98-.788-1.775-1.758-1.775h-7.671c-.971 0-1.76.796-1.76 1.775 0 .978.789 1.774 1.76 1.774h7.671c.97 0 1.758-.796 1.758-1.774z", fill: "currentColor" })));
}

function SvgFilter4(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M23.184 2.333H4.816c-1.371 0-2.482 1.146-2.482 2.56v1.824a2.6 2.6 0 00.67 1.75l6.974 7.67a.69.69 0 00.51.228l6.354.02a.683.683 0 00.492-.207l7.59-7.676c.475-.48.743-1.139.743-1.824V4.89c0-1.413-1.111-2.558-2.483-2.558z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M16.49 18.479l-5.663-.017a.65.65 0 00-.643.659v5.618c0 .315.157.61.415.78a.88.88 0 00.861.065l5.141-2.414a.932.932 0 00.529-.845v-3.187a.651.651 0 00-.64-.66z", fill: "currentColor" })));
}

function SvgFolder(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M19.699 5.967h-3.434a2.834 2.834 0 01-2.21-1.035l-1.13-1.563a2.761 2.761 0 00-2.2-1.035H8.299c-4.357 0-5.964 2.557-5.964 6.905v4.7c-.006.516 23.328.516 23.33 0v-1.367c.02-4.348-1.546-6.605-5.965-6.605z", fill: "currentColor" }),
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M24.304 7.634c.374.436.662.938.85 1.48a9.97 9.97 0 01.51 3.458v6.129c-.002.516-.04 1.031-.115 1.542a6.989 6.989 0 01-.933 2.547 5.172 5.172 0 01-.789 1.035 7 7 0 01-5.093 1.832H9.253a7.032 7.032 0 01-5.104-1.832 5.175 5.175 0 01-.778-1.035 6.803 6.803 0 01-.913-2.547 9.567 9.567 0 01-.125-1.542v-6.129c0-.512.028-1.023.083-1.532.012-.09.03-.177.047-.264.029-.145.057-.287.057-.43.106-.614.298-1.21.57-1.77.81-1.729 2.47-2.609 5.187-2.609h11.411a6.087 6.087 0 014.233 1.284c.138.117.266.245.383.383zM8.132 18.131h11.763a.967.967 0 001.007-.931.869.869 0 00-.208-.622.914.914 0 00-.726-.372H8.132a.964.964 0 100 1.925z", fill: "currentColor" })));
}

function SvgGame(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M15.523 6.863v.213c-.573-.01-1.145-.01-1.718-.01v-.192c0-.775-.652-1.405-1.43-1.405H11.24c-1.294 0-2.347-1.034-2.347-2.293 0-.46.389-.843.858-.843a.85.85 0 01.86.843.62.62 0 00.629.607h1.133c1.73.011 3.137 1.394 3.149 3.08z", fill: "currentColor" }),
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M17.692 7.096l1.105.014c3.973 0 6.87 2.833 6.87 6.744v5.024c0 3.911-2.897 6.744-6.87 6.744-1.591.033-3.183.045-4.785.045-1.603 0-3.218-.012-4.809-.045-3.973 0-6.87-2.833-6.87-6.744v-5.024c0-3.911 2.897-6.744 6.881-6.744 1.5-.022 3.034-.045 4.591-.045.573 0 1.145 0 1.718.012.722 0 1.443.01 2.169.02zM12.66 17.203h-1.202v1.192c0 .46-.39.843-.86.843a.85.85 0 01-.858-.843v-1.192H8.528a.85.85 0 01-.86-.843c0-.46.39-.843.86-.843H9.74v-1.18a.85.85 0 01.859-.843c.47 0 .859.383.859.843v1.18h1.202c.47 0 .858.383.858.843a.85.85 0 01-.858.843zm4.865-1.9h.115a.85.85 0 00.859-.842c0-.46-.39-.843-.859-.843h-.114a.843.843 0 100 1.686zm1.958 3.867h.115a.85.85 0 00.858-.843c0-.46-.389-.843-.858-.843h-.115a.843.843 0 100 1.686z", fill: "currentColor" })));
}

function SvgGraph(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M11.845 6.481c.06.121.099.25.116.384l.325 4.83.161 2.428c.002.25.041.497.117.736.194.462.663.756 1.173.736l7.766-.508c.337-.006.662.12.903.35.202.19.332.44.373.71l.014.163c-.322 4.45-3.59 8.163-8.032 9.121-4.441.958-8.995-1.066-11.19-4.974a9.584 9.584 0 01-1.162-3.67 7.02 7.02 0 01-.074-1.15c-.007-4.772 3.39-8.897 8.147-9.892a1.273 1.273 0 011.363.736z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M15.015 2.334c5.32.136 9.791 3.961 10.652 9.114l-.008.038-.024.055.003.152a.934.934 0 01-.223.55.966.966 0 01-.54.317l-.128.018-8.96.58a1.07 1.07 0 01-.817-.264 1.03 1.03 0 01-.336-.627l-.602-8.948a.143.143 0 010-.093.916.916 0 01.302-.647.951.951 0 01.681-.245z", fill: "currentColor" })));
}

function SvgHeart(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M13.739 25.477a42.304 42.304 0 01-7.383-5.784 14.78 14.78 0 01-3.536-5.605c-1.327-4.13.218-8.85 4.531-10.252a7.33 7.33 0 016.657 1.18 7.34 7.34 0 016.657-1.18c4.314 1.402 5.87 6.122 4.542 10.252a14.782 14.782 0 01-3.515 5.605 42.684 42.684 0 01-7.383 5.784l-.29.19-.28-.19z", fill: "currentColor" }),
        React.createElement("path", { d: "M14.013 25.667l-.274-.19a42.375 42.375 0 01-7.393-5.784 14.778 14.778 0 01-3.557-5.605c-1.317-4.13.228-8.85 4.542-10.252a7.346 7.346 0 016.682 1.193v20.638zM21.269 11.666a.839.839 0 01-.604-.324.954.954 0 01-.195-.69c.026-.82-.44-1.565-1.16-1.856-.455-.124-.732-.618-.617-1.105.108-.479.556-.777 1.007-.669.057.01.112.03.162.06 1.442.556 2.375 2.049 2.3 3.681a.942.942 0 01-.267.654.826.826 0 01-.626.249z", fill: "currentColor" })));
}

function SvgHelp(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 14 14", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("circle", { cx: 7, cy: 7, r: 6.5, stroke: "currentColor" }),
        React.createElement("path", { d: "M6.531 8.232c0-.213.035-.4.104-.56a1.59 1.59 0 01.264-.416c.107-.112.245-.245.416-.4.213-.187.37-.347.472-.48a.818.818 0 00.152-.496.744.744 0 00-.304-.624c-.203-.16-.483-.24-.84-.24-.624 0-1.101.21-1.432.632l-.584-.416a2.2 2.2 0 01.856-.664 2.997 2.997 0 011.216-.232c.581 0 1.043.128 1.384.384.341.25.512.597.512 1.04 0 .219-.037.413-.112.584-.07.165-.155.304-.256.416a5.96 5.96 0 01-.408.4c-.219.197-.381.37-.488.52a.96.96 0 00-.152.552h-.8zm.408 1.816a.526.526 0 01-.376-.144.516.516 0 01-.144-.368c0-.144.048-.264.144-.36a.51.51 0 01.376-.152c.15 0 .272.05.368.152a.488.488 0 01.144.36.501.501 0 01-.512.512z", fill: "currentColor" })));
}

function SvgHide(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, fillRule: "evenodd", clipRule: "evenodd", d: "M13.989 4.529H14c1.628 0 3.21.39 4.667 1.124l-3.802 3.838A5.265 5.265 0 0014 9.41c-2.515 0-4.553 2.055-4.553 4.594 0 .298.034.597.08.873l-4.211 4.25c-1.139-1.333-2.129-2.942-2.914-4.79a.875.875 0 010-.678C4.838 7.94 9.174 4.53 13.989 4.53zM21.5 7.642c1.65 1.516 3.05 3.56 4.098 6.018a.875.875 0 010 .678C23.163 20.058 18.826 23.48 14 23.48h-.011c-2.197 0-4.303-.724-6.158-2.045l3.608-3.64a4.58 4.58 0 002.561.792c2.504 0 4.542-2.056 4.542-4.583 0-.954-.296-1.85-.786-2.585l3.745-3.778z", fill: "currentColor" }),
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M21.501 7.641l2.072-2.09a.852.852 0 000-1.218.853.853 0 00-1.207 0l-1.07 1.08c-.011.023-.034.046-.057.069-.01.023-.034.046-.056.069l-1.014 1.023-3.608 3.641L4.348 22.538l-.034.046a.86.86 0 00.103 1.081c.159.171.387.252.603.252.216 0 .432-.08.603-.252L17.756 11.42l3.745-3.779zm-7.5 9.224c1.559 0 2.834-1.287 2.834-2.86 0-.483-.114-.942-.319-1.333l-3.836 3.871c.387.207.843.322 1.32.322z", fill: "currentColor" })));
}

function SvgHome(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M10.668 24.246v-3.578c0-.907.737-1.643 1.65-1.65h3.353c.918 0 1.661.74 1.661 1.65v3.567c0 .787.64 1.426 1.431 1.432h2.288a4.036 4.036 0 002.85-1.166 3.978 3.978 0 001.182-2.827V11.51c0-.857-.382-1.67-1.044-2.22l-7.772-6.17a3.634 3.634 0 00-4.617.083L4.044 9.29a2.887 2.887 0 00-1.128 2.22v10.152c0 2.211 1.805 4.004 4.032 4.004h2.235c.382.002.748-.146 1.019-.413.27-.267.423-.63.423-1.008h.042z", fill: "currentColor" })));
}

function SvgImage(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M19.055 25.667H8.944c-3.954 0-6.61-2.774-6.61-6.902V9.236c0-4.128 2.656-6.903 6.61-6.903h10.112c3.954 0 6.61 2.775 6.61 6.903v9.529c0 4.128-2.655 6.902-6.61 6.902z", fill: "currentColor" }),
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M13.12 10.12c0 1.6-1.301 2.9-2.9 2.9-1.6 0-2.899-1.3-2.899-2.9 0-1.597 1.3-2.9 2.9-2.9 1.598 0 2.898 1.303 2.898 2.9zm9.514 6.316c.272.263.467.564.595.885.389.97.187 2.137-.229 3.099a4.245 4.245 0 01-2.622 2.387 5.34 5.34 0 01-1.633.241H8.969c-.973 0-1.834-.226-2.54-.65-.442-.267-.52-.88-.193-1.278.549-.665 1.09-1.333 1.636-2.006 1.04-1.288 1.742-1.661 2.521-1.333.316.135.634.34.96.554.87.576 2.08 1.367 3.674.508 1.09-.595 1.722-1.614 2.272-2.502l.011-.018.11-.177c.188-.303.372-.6.581-.875.259-.34 1.22-1.401 2.463-.645.792.476 1.458 1.12 2.171 1.81z", fill: "currentColor" })));
}

function SvgImage4(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M25.667 17.153v1.614c0 .268-.012.538-.035.806-.328 3.685-2.888 6.094-6.582 6.094H8.95c-1.87 0-3.449-.607-4.583-1.708a5.358 5.358 0 01-1.11-1.438c.386-.469.818-.982 1.239-1.497a115.3 115.3 0 001.835-2.245c.643-.796 2.338-2.89 4.688-1.907.48.199.9.48 1.286.725.947.632 1.344.819 2.01.456.737-.397 1.216-1.181 1.72-2 .268-.434.537-.854.83-1.24 1.273-1.66 3.237-2.105 4.874-1.122.818.49 1.52 1.11 2.174 1.741.14.14.28.27.41.399.175.175.76.76 1.344 1.322z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M19.062 2.333H8.95c-3.963 0-6.616 2.772-6.616 6.9v9.534c0 1.438.327 2.714.923 3.755.386-.47.818-.983 1.24-1.499.712-.852 1.402-1.696 1.834-2.244.643-.796 2.338-2.89 4.688-1.907.48.199.9.48 1.286.725.947.632 1.345.82 2.01.455.737-.396 1.217-1.18 1.72-2 .268-.433.537-.852.83-1.238 1.273-1.661 3.237-2.106 4.874-1.123.818.49 1.52 1.11 2.174 1.741.14.14.28.27.41.4.175.173.76.758 1.344 1.32V9.234c0-4.128-2.654-6.9-6.605-6.9z", fill: "currentColor" }),
        React.createElement("path", { d: "M13.364 10.263c0 1.643-1.37 3.012-3.012 3.012-1.641 0-3.01-1.369-3.01-3.012 0-1.642 1.369-3.012 3.01-3.012 1.643 0 3.012 1.37 3.012 3.012z", fill: "currentColor" })));
}

function SvgInfoCircleOutline(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 24 24", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M11 15h2v2h-2v-2zm0-8h2v6h-2V7zm.99-5C6.47 2 2 6.48 2 12s4.47 10 9.99 10C17.52 22 22 17.52 22 12S17.52 2 11.99 2zM12 20c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8z", fill: "currentColor" })));
}

function SvgInfoCircle(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M25.666 14c0 6.444-5.223 11.666-11.666 11.666-6.444 0-11.667-5.222-11.667-11.666C2.333 7.557 7.556 2.333 14 2.333c6.443 0 11.666 5.224 11.666 11.667z", fill: "currentColor" }),
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M15.015 14.736c0 .562-.459 1.02-1.021 1.02-.562 0-1.02-.458-1.02-1.02V9.579c0-.562.458-1.02 1.02-1.02s1.02.458 1.02 1.02v5.157zm-2.036 3.701a1.025 1.025 0 012.048 0c0 .563-.458 1.021-1.021 1.021a1.025 1.025 0 01-1.027-1.02z", fill: "currentColor" })));
}

function SvgInfoSquare(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M19.064 2.333H8.948c-3.955 0-6.615 2.777-6.615 6.907v9.531c0 4.119 2.66 6.895 6.615 6.895h10.116c3.954 0 6.603-2.776 6.603-6.895V9.24c0-4.13-2.649-6.907-6.604-6.907z", fill: "currentColor" }),
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M12.978 9.554a1.024 1.024 0 002.048 0c0-.562-.458-1.02-1.021-1.02-.566 0-1.027.458-1.027 1.02zm2.037 3.702c0-.563-.459-1.021-1.021-1.021-.562 0-1.02.458-1.02 1.02v5.157c0 .563.458 1.021 1.02 1.021s1.02-.458 1.02-1.02v-5.157z", fill: "currentColor" })));
}

function SvgLocation(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M9.954 3.426a8.038 8.038 0 018.207.068c2.5 1.554 4.02 4.328 4.006 7.311-.059 2.964-1.688 5.75-3.725 7.904a21.849 21.849 0 01-3.918 3.29 1.37 1.37 0 01-.475.168.958.958 0 01-.456-.139 21.604 21.604 0 01-5.645-5.305 10.826 10.826 0 01-2.115-6.066c-.001-2.99 1.572-5.75 4.12-7.23zm1.473 8.468a2.774 2.774 0 002.563 1.746 2.729 2.729 0 001.964-.818 2.833 2.833 0 00.81-1.997 2.827 2.827 0 00-1.705-2.618 2.737 2.737 0 00-3.027.606 2.864 2.864 0 00-.605 3.08z", fill: "currentColor" }),
        React.createElement("ellipse", { opacity: 0.4, cx: 14, cy: 24.5, rx: 5.833, ry: 1.167, fill: "currentColor" })));
}

function SvgLock(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M20.289 8.517v1.843a5.525 5.525 0 00-1.767-.292h-.011V8.517c0-2.439-2.016-4.434-4.505-4.434h-.012c-2.49 0-4.505 1.973-4.517 4.41v1.575h-.012a5.58 5.58 0 00-1.766.292V8.517c.012-3.43 2.833-6.184 6.283-6.184h.036c3.45 0 6.27 2.777 6.27 6.184z", fill: "currentColor" }),
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M18.523 10.068c.616 0 1.22.107 1.766.292 2.11.723 3.628 2.685 3.628 5.005v5.005c0 2.917-2.419 5.297-5.394 5.297H9.466c-2.964 0-5.382-2.38-5.382-5.297v-5.005c0-2.32 1.517-4.282 3.615-5.005a5.58 5.58 0 011.767-.292h9.057zm-4.529 10.115a1.03 1.03 0 001.043-1.026v-2.59c0-.56-.462-1.015-1.043-1.015-.569 0-1.031.456-1.031 1.015v2.59c0 .571.462 1.026 1.031 1.026z", fill: "currentColor" })));
}

function SvgLogin(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M8.512 7.52c0-2.86 2.403-5.187 5.357-5.187h5.87c2.947 0 5.344 2.322 5.344 5.176v12.968c0 2.861-2.402 5.19-5.355 5.19h-5.871c-2.947 0-5.345-2.323-5.345-5.178V7.52z", fill: "currentColor" }),
        React.createElement("path", { d: "M18.71 13.363l-3.462-3.394a.922.922 0 00-1.29.002.89.89 0 00.002 1.27l1.895 1.86H3.83a.906.906 0 00-.913.899c0 .496.41.897.913.897h12.027l-1.896 1.86a.889.889 0 00-.003 1.27.919.919 0 001.29.002l3.463-3.393a.893.893 0 00.27-.636.893.893 0 00-.27-.637z", fill: "currentColor" })));
}

function SvgLogout(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M2.333 7.521c0-2.859 2.37-5.188 5.28-5.188H13.4c2.904 0 5.267 2.322 5.267 5.177v12.968c0 2.861-2.369 5.189-5.28 5.189H7.601c-2.905 0-5.268-2.322-5.268-5.177V7.522z", fill: "currentColor" }),
        React.createElement("path", { d: "M25.409 13.364l-3.32-3.394a.858.858 0 00-1.238.002c-.34.353-.34.92.003 1.27l1.819 1.86H11.14a.887.887 0 00-.875.898c0 .497.392.898.875.898h11.533l-1.82 1.859a.916.916 0 00-.002 1.27.863.863 0 00.62.265.864.864 0 00.618-.263l3.32-3.392a.914.914 0 000-1.273z", fill: "currentColor" })));
}

function SvgMenu(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M11 3h.594a1.72 1.72 0 011.719 1.719v9.625a1.72 1.72 0 01-1.72 1.719H4.72A1.72 1.72 0 013 14.342V4.72A1.72 1.72 0 014.719 3H11zM4.719 17.438h6.875a1.72 1.72 0 011.719 1.718v4.125A1.72 1.72 0 0111.592 25H4.72A1.72 1.72 0 013 23.281v-4.125a1.72 1.72 0 011.719-1.718zM25 22.7v.581A1.72 1.72 0 0123.281 25h-6.875a1.72 1.72 0 01-1.718-1.719v-9.625a1.72 1.72 0 011.718-1.719h6.875A1.72 1.72 0 0125 13.658V22.7zM25 8.5v.344a1.72 1.72 0 01-1.719 1.719h-6.875a1.72 1.72 0 01-1.718-1.72V4.72A1.72 1.72 0 0116.405 3h6.875A1.72 1.72 0 0125 4.719V8.5z", fill: "currentColor" })));
}

function SvgMessage(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M25.666 18.597a5.888 5.888 0 01-5.868 5.903H8.225c-3.244 0-5.892-2.625-5.892-5.88v-.011s.007-5.164.016-7.761a.581.581 0 01.943-.457c2.772 2.199 7.73 6.209 7.791 6.261a4.745 4.745 0 002.952 1.038 4.682 4.682 0 002.951-1.05c.062-.042 4.909-3.931 7.723-6.167a.583.583 0 01.946.455c.011 2.578.011 7.669.011 7.669z", fill: "currentColor" }),
        React.createElement("path", { d: "M25.055 6.62A5.874 5.874 0 0019.87 3.5H8.225a5.874 5.874 0 00-5.187 3.12c-.226.425-.119.956.258 1.257l8.663 6.929c.606.49 1.341.734 2.076.734h.023c.736 0 1.47-.244 2.077-.734l8.663-6.93c.377-.3.484-.831.258-1.257z", fill: "currentColor" })));
}

function SvgMoreCircle(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M25.667 14c0 6.444-5.223 11.666-11.667 11.666-6.443 0-11.666-5.222-11.666-11.666C2.334 7.557 7.557 2.333 14 2.333c6.444 0 11.667 5.224 11.667 11.667z", fill: "currentColor" }),
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M8.775 12.604c-.772 0-1.398.627-1.398 1.395a1.4 1.4 0 001.398 1.398A1.4 1.4 0 0010.172 14c0-.768-.626-1.395-1.397-1.395zm5.225 0c-.77 0-1.397.627-1.397 1.395A1.4 1.4 0 0014 15.397 1.4 1.4 0 0015.398 14c0-.768-.627-1.395-1.398-1.395zM17.828 14a1.398 1.398 0 012.796 0 1.4 1.4 0 01-1.398 1.398A1.4 1.4 0 0117.828 14z", fill: "currentColor" })));
}

function SvgMoreSquare(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M19.064 2.333H8.948c-3.955 0-6.615 2.777-6.615 6.907v9.531c0 4.119 2.66 6.895 6.615 6.895h10.116c3.954 0 6.603-2.776 6.603-6.895V9.24c0-4.13-2.649-6.907-6.604-6.907z", fill: "currentColor" }),
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M8.775 12.604c-.772 0-1.398.627-1.398 1.395a1.4 1.4 0 001.398 1.398A1.4 1.4 0 0010.172 14c0-.768-.626-1.395-1.397-1.395zm5.225 0c-.771 0-1.398.627-1.398 1.395A1.4 1.4 0 0014 15.397 1.4 1.4 0 0015.398 14c0-.768-.627-1.395-1.398-1.395zM17.828 14a1.398 1.398 0 012.796 0 1.4 1.4 0 01-1.398 1.398A1.4 1.4 0 0117.828 14z", fill: "currentColor" })));
}

function SvgMov(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 32 32", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M7.548 29h16.687c.855 0 1.548-.693 1.548-1.547V8.483l-3.018-2.513L19.23 3H7.548C6.693 3 6 3.693 6 4.548v22.904C6 28.308 6.693 29 7.548 29z", fill: "currentColor" }),
        React.createElement("path", { d: "M13.963 15.032V19h-.966v-2.481L12.137 19h-.836l-.865-2.487V19H9.47v-3.968h1.181l1.08 2.764 1.057-2.764h1.175zm2.567-.09a2 2 0 011.023.265c.309.174.552.417.729.73.177.309.266.659.266 1.05 0 .393-.09.745-.272 1.058-.177.313-.42.557-.729.735-.305.173-.644.26-1.017.26-.373 0-.714-.087-1.023-.26a1.978 1.978 0 01-.73-.735 2.107 2.107 0 01-.265-1.057c0-.392.088-.742.266-1.051.18-.313.423-.556.729-.73.309-.177.65-.265 1.023-.265zm0 .898c-.317 0-.57.104-.758.311-.184.204-.277.483-.277.837 0 .35.093.63.277.836.189.208.441.311.758.311.313 0 .563-.103.752-.31.188-.208.282-.487.282-.837s-.094-.63-.282-.837c-.185-.207-.436-.31-.752-.31zm3.307-.836l.977 3.007.978-3.007h1.035L21.437 19h-1.25l-1.385-3.996h1.035z", fill: "#fff" }),
        React.createElement("path", { d: "M19.225 6.985L19.206 3l6.526 5.545-4.966-.02a1.547 1.547 0 01-1.541-1.54z", fill: "currentColor" })));
}

function SvgNotification(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M23.065 13.586c-.853-.995-1.24-1.857-1.24-3.323v-.498c0-1.91-.44-3.14-1.395-4.37-1.472-1.91-3.951-3.062-6.378-3.062h-.103c-2.376 0-4.778 1.099-6.276 2.932-1.007 1.255-1.498 2.538-1.498 4.5v.498c0 1.466-.362 2.328-1.24 3.323-.645.733-.851 1.676-.851 2.696a4.21 4.21 0 001.007 2.774 5.288 5.288 0 003.384 1.648c1.833.21 3.666.288 5.526.288 1.858 0 3.692-.131 5.526-.288a5.287 5.287 0 003.382-1.648 4.216 4.216 0 001.008-2.774c0-1.02-.207-1.963-.852-2.696z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M16.344 22.433c-.584-.125-4.138-.125-4.72 0-.5.115-1.039.383-1.039.97.03.561.358 1.056.812 1.37h-.001c.588.459 1.278.75 2 .855.385.053.777.05 1.176 0a4.243 4.243 0 001.999-.854l-.001-.002c.454-.313.782-.808.811-1.368 0-.588-.539-.856-1.037-.97z", fill: "currentColor" })));
}

function SvgOut(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 20 20", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M14.167 5.833l-1.175 1.175 2.15 2.159H6.667v1.666h8.475l-2.15 2.15 1.175 1.184L18.333 10l-4.166-4.167zM3.333 4.167H10V2.5H3.333c-.916 0-1.666.75-1.666 1.667v11.666c0 .917.75 1.667 1.666 1.667H10v-1.667H3.333V4.167z", fill: "currentColor" })));
}

function SvgPaperDownload(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M21.944 10.524c-.527 0-1.224-.011-2.093-.011-2.119 0-3.86-1.754-3.86-3.892V2.869a.533.533 0 00-.53-.536h-6.17c-2.879 0-5.208 2.364-5.208 5.26v12.572c0 3.039 2.44 5.502 5.45 5.502h9.187c2.87 0 5.197-2.349 5.197-5.248v-9.37a.53.53 0 00-.53-.534c-.492.004-1.084.01-1.443.01z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M18.765 2.995a.557.557 0 00-.958.39V6.46a2.363 2.363 0 002.352 2.352c.815.01 1.944.012 2.903.01a.556.556 0 00.4-.943c-1.23-1.28-3.434-3.573-4.697-4.885z", fill: "currentColor" }),
        React.createElement("path", { d: "M17.623 14.827a.87.87 0 00-1.23.002l-1.854 1.863v-5.631a.87.87 0 00-1.738 0v5.631l-1.855-1.863a.868.868 0 10-1.232 1.226l3.34 3.356h.002a.868.868 0 001.228.001l.002-.001 3.34-3.356a.868.868 0 00-.003-1.228z", fill: "currentColor" })));
}

function SvgPaperFail(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M21.944 10.524c-.527 0-1.224-.011-2.093-.011-2.119 0-3.86-1.754-3.86-3.892V2.869a.533.533 0 00-.53-.536h-6.17c-2.879 0-5.208 2.364-5.208 5.26v12.572c0 3.039 2.44 5.502 5.45 5.502h9.187c2.87 0 5.197-2.349 5.197-5.248v-9.37a.53.53 0 00-.53-.534c-.492.004-1.084.01-1.443.01z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M18.765 2.995a.557.557 0 00-.958.39V6.46a2.364 2.364 0 002.353 2.352c.813.01 1.943.012 2.902.01a.556.556 0 00.4-.943l-4.697-4.885z", fill: "currentColor" }),
        React.createElement("path", { d: "M15.091 15.15l1.425-1.426a.868.868 0 10-1.228-1.227l-1.425 1.423-1.425-1.424a.87.87 0 00-1.23 1.228l1.426 1.425-1.426 1.425a.867.867 0 00.615 1.483.865.865 0 00.615-.256l1.425-1.423 1.424 1.423a.864.864 0 001.228 0 .867.867 0 000-1.227l-1.424-1.425z", fill: "currentColor" })));
}

function SvgPaperNegative(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M21.944 10.524c-.527 0-1.224-.011-2.093-.011-2.119 0-3.86-1.754-3.86-3.892V2.869a.533.533 0 00-.53-.536h-6.17c-2.879 0-5.208 2.364-5.208 5.26v12.572c0 3.039 2.44 5.502 5.45 5.502h9.187c2.87 0 5.197-2.349 5.197-5.248v-9.37a.53.53 0 00-.53-.534c-.492.004-1.084.01-1.443.01z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M18.765 2.995a.557.557 0 00-.958.39V6.46a2.364 2.364 0 002.353 2.352c.813.01 1.942.012 2.903.01a.556.556 0 00.399-.943l-4.697-4.885z", fill: "currentColor" }),
        React.createElement("path", { d: "M16.762 16.997h-5.767a.869.869 0 110-1.737h5.767a.869.869 0 110 1.737z", fill: "currentColor" })));
}

function SvgPaperPlus(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M21.944 10.524c-.527 0-1.225-.011-2.093-.011-2.119 0-3.861-1.754-3.861-3.892V2.869a.532.532 0 00-.528-.536h-6.17c-2.88 0-5.208 2.364-5.208 5.26v12.572c0 3.039 2.438 5.502 5.447 5.502h9.189c2.87 0 5.197-2.349 5.197-5.248v-9.37a.53.53 0 00-.53-.534c-.491.004-1.084.01-1.443.01z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M18.765 2.995a.557.557 0 00-.958.39V6.46a2.364 2.364 0 002.352 2.352c.815.01 1.944.012 2.903.01a.556.556 0 00.4-.943l-4.697-4.885z", fill: "currentColor" }),
        React.createElement("path", { d: "M16.762 14.276h-2.016V12.26a.869.869 0 10-1.737 0v2.015h-2.015a.869.869 0 000 1.738h2.015v2.014a.87.87 0 001.737 0v-2.014h2.016a.87.87 0 000-1.738z", fill: "currentColor" })));
}

function SvgPaperSuccess(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 23 23", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M17.674 8.477c-.424 0-.986-.01-1.686-.01-1.706 0-3.11-1.412-3.11-3.134V2.31a.429.429 0 00-.425-.432h-4.97c-2.319 0-4.194 1.904-4.194 4.237v10.125c0 2.448 1.965 4.431 4.388 4.431h7.4c2.312 0 4.186-1.891 4.186-4.226V8.9a.426.426 0 00-.426-.43c-.397.002-.874.007-1.163.007z", fill: "currentColor" }),
        React.createElement("path", { d: "M10.16 16.207a.82.82 0 01-.58-.24l-2.23-2.23a.821.821 0 111.162-1.163l1.649 1.649 3.879-3.879a.821.821 0 111.162 1.163l-4.46 4.46a.82.82 0 01-.581.24z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M15.113 2.413a.449.449 0 00-.771.314v2.478c0 1.04.856 1.895 1.895 1.895.655.007 1.565.009 2.337.007a.448.448 0 00.322-.76l-3.783-3.934z", fill: "currentColor" })));
}

function SvgPaperUpload(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M21.944 10.524c-.527 0-1.225-.011-2.093-.011-2.119 0-3.861-1.754-3.861-3.892V2.869a.532.532 0 00-.528-.536h-6.17c-2.88 0-5.208 2.364-5.208 5.26v12.572c0 3.039 2.438 5.502 5.447 5.502h9.189c2.87 0 5.197-2.349 5.197-5.248v-9.37a.53.53 0 00-.53-.534c-.491.004-1.084.01-1.443.01z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M18.765 2.995a.557.557 0 00-.958.39V6.46a2.364 2.364 0 002.352 2.352c.815.01 1.944.012 2.903.01a.556.556 0 00.4-.943l-4.697-4.885z", fill: "currentColor" }),
        React.createElement("path", { d: "M17.623 15.031a.87.87 0 01-1.23-.002l-1.854-1.864v5.632a.87.87 0 01-1.737 0v-5.632l-1.856 1.864a.868.868 0 11-1.23-1.226l3.338-3.355h.001a.859.859 0 01.28-.188.861.861 0 01.671 0 .876.876 0 01.278.186l.002.002 3.34 3.354a.868.868 0 01-.003 1.229z", fill: "currentColor" })));
}

function SvgPaper(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M21.944 10.524c-.527 0-1.225-.011-2.093-.011-2.119 0-3.861-1.754-3.861-3.892V2.869a.532.532 0 00-.528-.536h-6.17c-2.88 0-5.208 2.364-5.208 5.26v12.572c0 3.039 2.438 5.502 5.447 5.502h9.19c2.87 0 5.196-2.349 5.196-5.248v-9.37a.528.528 0 00-.528-.534c-.493.004-1.085.01-1.445.01z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M18.765 2.995a.557.557 0 00-.958.39V6.46a2.364 2.364 0 002.353 2.352c.813.01 1.943.012 2.902.01a.556.556 0 00.4-.943l-4.697-4.885z", fill: "currentColor" }),
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M10.47 13.286h3.949a.869.869 0 100-1.738h-3.95a.869.869 0 000 1.738zm0 5.826h6.351a.869.869 0 100-1.737H10.47a.869.869 0 000 1.737z", fill: "currentColor" })));
}

function SvgPassword(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M19.057 2.333H8.943c-3.954 0-6.609 2.774-6.609 6.903v9.528c0 4.128 2.655 6.902 6.61 6.902h10.112c3.954 0 6.611-2.774 6.611-6.902V9.236c0-4.129-2.656-6.903-6.61-6.903z", fill: "currentColor" }),
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M13.2 13.123h6.65c.478 0 .875.397.875.875v2.159c0 .49-.397.875-.875.875a.867.867 0 01-.875-.875v-1.284h-1.552v1.284c0 .49-.396.875-.875.875a.867.867 0 01-.875-.875v-1.284H13.2a3.01 3.01 0 01-2.882 2.159 3.037 3.037 0 01-3.045-3.034 3.045 3.045 0 013.045-3.033 3.01 3.01 0 012.882 2.158zm-4.177.875a1.29 1.29 0 002.579 0 1.29 1.29 0 00-2.578 0z", fill: "currentColor" })));
}

function SvgPdf(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 58 76", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M4.7 75.375h47.976a4.45 4.45 0 004.449-4.45V16.394l-8.676-7.227L38.29.625H4.7a4.45 4.45 0 00-4.45 4.45v65.85a4.45 4.45 0 004.45 4.45z", fill: "currentColor" }),
        React.createElement("path", { d: "M17.288 42.595v4.03H14.51V35.136h4.501c1.365 0 2.405.342 3.12 1.024.715.672 1.072 1.582 1.072 2.73 0 .715-.162 1.354-.487 1.918-.314.552-.785.991-1.414 1.316-.628.314-1.392.471-2.291.471h-1.723zm1.414-2.226c1.116 0 1.674-.493 1.674-1.479 0-1.007-.558-1.511-1.674-1.511h-1.414v2.99h1.414zM34.906 40.856c0 1.127-.244 2.13-.731 3.007-.477.866-1.17 1.544-2.08 2.031-.9.488-1.961.731-3.185.731h-4.34V35.136h4.34c1.235 0 2.302.239 3.2.715a4.936 4.936 0 012.065 2.016c.487.866.73 1.863.73 2.99zm-6.24 3.283c1.083 0 1.923-.287 2.519-.861.606-.574.91-1.381.91-2.422 0-1.04-.304-1.847-.91-2.42-.596-.575-1.436-.862-2.52-.862H27.35v6.565h1.316zM43.98 35.136v2.21h-4.713v2.52h3.64v2.112h-3.64v4.647h-2.779V35.136h7.492z", fill: "#fff" }),
        React.createElement("path", { d: "M38.27 12.083L38.216.625l18.76 15.943-14.275-.057a4.45 4.45 0 01-4.431-4.428z", fill: "currentColor" })));
}

function SvgPeopleSetting(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 20 20", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M8.333 10a3.333 3.333 0 100-6.667 3.333 3.333 0 000 6.667zM8.892 10.85c-.184-.008-.367-.017-.559-.017-2.016 0-3.9.559-5.508 1.517-.733.433-1.158 1.25-1.158 2.108v2.209h7.716a5.803 5.803 0 01-.491-5.817zM17.292 13.333c0-.183-.025-.35-.05-.525l.95-.841-.834-1.442-1.208.408a3.04 3.04 0 00-.9-.525L15 9.167h-1.667l-.25 1.241a3.04 3.04 0 00-.9.525l-1.208-.408-.833 1.442.95.841c-.025.175-.05.342-.05.525 0 .184.025.35.05.525l-.95.842.833 1.442 1.208-.409c.267.225.567.4.9.525l.25 1.242H15l.25-1.242c.333-.125.633-.3.9-.525l1.208.409.834-1.442-.95-.842c.025-.175.05-.341.05-.525zM14.167 15c-.917 0-1.667-.75-1.667-1.667 0-.916.75-1.666 1.667-1.666.916 0 1.666.75 1.666 1.666 0 .917-.75 1.667-1.666 1.667z", fill: "currentColor" })));
}

function SvgPlay(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M25.667 14.006c0 6.427-5.237 11.66-11.667 11.66S2.334 20.434 2.334 14.007C2.334 7.567 7.57 2.333 14 2.333c6.43 0 11.667 5.234 11.667 11.673z", fill: "currentColor" }),
        React.createElement("path", { d: "M18.667 14.006c0 .294-.093.59-.279.828a4.496 4.496 0 01-.324.362l-.07.069c-.974 1.033-3.399 2.586-4.629 3.084 0 .011-.73.308-1.078.318h-.047a1.464 1.464 0 01-1.287-.77c-.14-.262-.267-1.022-.279-1.032-.104-.682-.174-1.725-.174-2.87 0-1.202.07-2.291.197-2.96 0-.012.128-.624.21-.828.127-.294.359-.545.649-.704.232-.112.475-.17.73-.17.267.013.766.182.963.261 1.3.5 3.782 2.132 4.733 3.13.163.159.337.353.383.397.197.25.302.556.302.885z", fill: "currentColor" })));
}

function SvgPlus(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M19.445 2.333H8.555c-3.971 0-6.221 2.25-6.221 6.223v10.888c0 3.962 2.24 6.223 6.222 6.223h10.889c3.971 0 6.222-2.261 6.222-6.223V8.556c0-3.972-2.25-6.223-6.222-6.223z", fill: "currentColor" }),
        React.createElement("path", { d: "M17.874 14.826h-3V17.8a.87.87 0 01-.874.867.87.87 0 01-.874-.867v-2.974h-3a.879.879 0 01-.792-.871c0-.45.342-.825.792-.872h2.99V10.12a.881.881 0 01.88-.786c.452 0 .832.34.879.786v2.964h2.999c.45.047.793.423.793.872a.879.879 0 01-.793.871z", fill: "currentColor" })));
}

function SvgPptx(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 32 32", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M7.548 29h16.687c.855 0 1.548-.693 1.548-1.547V8.483l-3.018-2.513L19.23 3H7.548C6.693 3 6 3.693 6 4.548v22.904C6 28.308 6.693 29 7.548 29z", fill: "currentColor" }),
        React.createElement("path", { d: "M10.188 17.598V19H9.22v-3.996h1.566c.475 0 .836.119 1.085.356.249.234.373.55.373.95 0 .248-.056.47-.17.667a1.16 1.16 0 01-.491.457c-.219.11-.484.164-.797.164h-.6zm.492-.774c.388 0 .582-.172.582-.514 0-.35-.194-.526-.582-.526h-.492v1.04h.492zm3.007.774V19h-.966v-3.996h1.566c.474 0 .836.119 1.085.356.248.234.373.55.373.95 0 .248-.057.47-.17.667a1.16 1.16 0 01-.492.457c-.218.11-.484.164-.796.164h-.6zm.492-.774c.388 0 .582-.172.582-.514 0-.35-.194-.526-.582-.526h-.492v1.04h.492zm4.913-1.82v.769h-1.086V19h-.972v-3.227H15.96v-.77h3.132zM21.924 19l-.842-1.244L20.358 19H19.25l1.278-2.057-1.317-1.94h1.147l.82 1.205.706-1.204h1.102l-1.26 2.012L23.071 19h-1.147z", fill: "#fff" }),
        React.createElement("path", { d: "M19.225 6.985L19.206 3l6.526 5.545-4.966-.02a1.547 1.547 0 01-1.541-1.54z", fill: "currentColor" })));
}

function SvgPreview(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 24 24", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M19 3H5a2 2 0 00-2 2v14a2 2 0 002 2h14c1.1 0 2-.9 2-2V5a2 2 0 00-2-2zm0 16H5V7h14v12zm-5.5-6c0 .83-.67 1.5-1.5 1.5s-1.5-.67-1.5-1.5.67-1.5 1.5-1.5 1.5.67 1.5 1.5zM12 9c-2.73 0-5.06 1.66-6 4 .94 2.34 3.27 4 6 4s5.06-1.66 6-4c-.94-2.34-3.27-4-6-4zm0 6.5a2.5 2.5 0 010-5 2.5 2.5 0 010 5z", fill: "currentColor" })));
}

function SvgProfile(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M13.996 17.704c-5.032 0-9.33.793-9.33 3.966 0 3.175 4.272 3.996 9.33 3.996 5.032 0 9.33-.792 9.33-3.966 0-3.175-4.27-3.996-9.33-3.996z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M13.996 14.681a6.152 6.152 0 006.174-6.174 6.152 6.152 0 00-6.174-6.174 6.153 6.153 0 00-6.174 6.174 6.153 6.153 0 006.174 6.174z", fill: "currentColor" })));
}

function SvgRemoveIcon(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 20 21", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M12.159 7.167L10 9.325 7.842 7.167 6.667 8.342 8.825 10.5l-2.158 2.158 1.175 1.175L10 11.675l2.159 2.158 1.175-1.175-2.159-2.158 2.159-2.158-1.175-1.175zm-2.159-5A8.326 8.326 0 001.667 10.5 8.326 8.326 0 0010 18.833a8.326 8.326 0 008.334-8.333A8.326 8.326 0 0010 2.167zm0 15A6.675 6.675 0 013.334 10.5 6.676 6.676 0 0110 3.833a6.676 6.676 0 016.667 6.667A6.675 6.675 0 0110 17.167z", fill: "currentColor" })));
}

function SvgRemove(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 32 32", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M22 10L10 22M10 10l12 12", stroke: "currentColor", strokeWidth: 2, strokeLinecap: "round", strokeLinejoin: "round" })));
}

function SvgScan(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, fillRule: "evenodd", clipRule: "evenodd", d: "M10.72 4.372a.88.88 0 00-.888-.872h-.001l-1.9.001c-2.557.002-4.637 2.045-4.637 4.552v2.17c0 .48.398.871.888.871s.889-.391.889-.872V8.053c0-1.548 1.283-2.807 2.86-2.81h1.901a.88.88 0 00.888-.871zm9.339-.872h-1.858a.88.88 0 00-.888.872c0 .48.398.87.888.87h1.858c1.583 0 2.871 1.263 2.871 2.815v2.166c0 .48.398.871.888.871a.88.88 0 00.888-.871V8.057c0-2.513-2.084-4.557-4.647-4.557zm-9.281 4.366h6.445a2.65 2.65 0 011.877.774c.497.5.772 1.171.771 1.87v1.453a.326.326 0 01-.319.314H8.446a.324.324 0 01-.315-.314V10.51c-.013-1.447 1.172-2.629 2.647-2.644z", fill: "currentColor" }),
        React.createElement("path", { d: "M25.945 14.048H2.055c-.49 0-.889.39-.889.872 0 .48.4.87.89.87h1.237v4.157c0 2.508 2.082 4.55 4.638 4.552l1.9.001a.88.88 0 00.89-.872.88.88 0 00-.889-.87l-1.899-.002c-1.578-.002-2.863-1.261-2.863-2.81V15.79h3.06v1.157c-.011 1.447 1.173 2.63 2.647 2.644h6.445c1.476-.014 2.66-1.197 2.648-2.644v-1.157h3.06v4.153c0 1.554-1.287 2.816-2.87 2.816H18.2a.88.88 0 00-.889.87.88.88 0 00.889.872h1.858c2.563 0 4.647-2.043 4.647-4.558V15.79h1.24c.49 0 .887-.389.887-.87a.88.88 0 00-.888-.87z", fill: "currentColor" })));
}

function SvgSearchOutline(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 24 24", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("circle", { cx: 11, cy: 11, r: 7, stroke: "currentColor", strokeWidth: 2 }),
        React.createElement("path", { d: "M20 20l-3-3", stroke: "currentColor", strokeWidth: 2, strokeLinecap: "round" })));
}

function SvgSearchSingleLine(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 32 32", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("circle", { cx: 15, cy: 15, r: 7, stroke: "currentColor", strokeWidth: 2 }),
        React.createElement("path", { d: "M15 12a3 3 0 00-3 3M24 24l-3-3", stroke: "currentColor", strokeWidth: 2, strokeLinecap: "round" })));
}

function SvgSearch(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("ellipse", { cx: 12.366, cy: 12.429, rx: 10.032, ry: 10.095, fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M24.12 25.614a1.542 1.542 0 01-1.037-.448l-2.376-2.777a1.269 1.269 0 01-.093-1.775 1.138 1.138 0 011.618 0l2.988 2.39c.43.441.564 1.095.34 1.67a1.557 1.557 0 01-1.377.993l-.063-.053z", fill: "currentColor" })));
}

function SvgSend(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M24.999 3.008a2.261 2.261 0 00-2.252-.583L3.975 7.849A2.233 2.233 0 002.362 9.61c-.166.87.413 1.977 1.169 2.439l5.87 3.584a1.527 1.527 0 001.877-.223l6.72-6.721a.858.858 0 011.237 0 .88.88 0 010 1.236l-6.732 6.722c-.5.499-.593 1.274-.226 1.877l3.587 5.891a2.233 2.233 0 001.936 1.097c.094 0 .199 0 .292-.013a2.268 2.268 0 001.902-1.61l5.565-18.63a2.267 2.267 0 00-.56-2.252z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, fillRule: "evenodd", clipRule: "evenodd", d: "M3.512 19.61a.874.874 0 01-.618-1.493l1.593-1.595a.877.877 0 011.237 0c.341.342.341.896 0 1.238l-1.593 1.592a.868.868 0 01-.619.257zM7.901 21a.874.874 0 01-.618-1.493l1.592-1.594a.877.877 0 011.238 0c.34.342.34.896 0 1.238l-1.594 1.593A.868.868 0 017.9 21zm.295 4.163c.17.171.395.257.619.257a.868.868 0 00.618-.257l1.594-1.593a.877.877 0 000-1.237.877.877 0 00-1.238 0l-1.593 1.593a.874.874 0 000 1.237z", fill: "currentColor" })));
}

function SvgSetting(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M14.014 17.302c-1.872 0-3.386-1.459-3.386-3.29 0-1.832 1.514-3.302 3.386-3.302s3.35 1.47 3.35 3.302c0 1.831-1.478 3.29-3.35 3.29z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M24.768 16.765c-.226-.35-.548-.7-.965-.922-.334-.163-.549-.431-.74-.746-.608-1.004-.25-2.322.763-2.917a2.365 2.365 0 00.883-3.302l-.8-1.376a2.464 2.464 0 00-3.35-.887c-1.049.56-2.396.187-3.004-.805-.19-.327-.298-.677-.274-1.027.036-.455-.107-.886-.322-1.236-.441-.724-1.24-1.214-2.122-1.214h-1.681a2.56 2.56 0 00-2.11 1.214c-.227.35-.358.781-.335 1.236.024.35-.083.7-.274 1.027-.608.992-1.955 1.365-2.993.805a2.479 2.479 0 00-3.362.887l-.799 1.376a2.385 2.385 0 00.883 3.302c1.013.595 1.37 1.913.775 2.917-.203.315-.418.583-.751.746-.406.222-.764.572-.954.922-.441.723-.418 1.633.024 2.392l.822 1.4a2.49 2.49 0 002.122 1.213 2.52 2.52 0 001.264-.35c.298-.198.656-.268 1.05-.268 1.18 0 2.17.968 2.193 2.123 0 1.342 1.097 2.392 2.48 2.392h1.622c1.37 0 2.468-1.05 2.468-2.392.036-1.155 1.025-2.123 2.206-2.123.381 0 .739.07 1.049.268.381.233.846.35 1.263.35.847 0 1.67-.467 2.11-1.213l.835-1.4c.43-.782.465-1.669.024-2.392z", fill: "currentColor" })));
}

function SvgShieldDone(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M14.101 25.667a.912.912 0 01-.42-.101l-4.2-2.175c-1.193-.618-2.125-1.31-2.853-2.118a9.617 9.617 0 01-2.495-6.386l-.05-7.742a2.115 2.115 0 011.433-1.997l7.715-2.69a2.196 2.196 0 011.435-.008l7.744 2.598a2.11 2.11 0 011.457 1.978l.05 7.747a9.616 9.616 0 01-2.41 6.411c-.72.82-1.645 1.523-2.825 2.152l-4.164 2.224a.892.892 0 01-.417.107z", fill: "currentColor" }),
        React.createElement("path", { d: "M13.206 16.708a.89.89 0 01-.625-.247l-2.236-2.151a.842.842 0 01-.007-1.213.898.898 0 011.246-.008l1.609 1.547 3.929-3.874a.898.898 0 011.246-.008c.346.334.35.878.008 1.213l-4.549 4.486a.887.887 0 01-.621.255z", fill: "currentColor" })));
}

function SvgShieldFail(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M14.1 25.667a.908.908 0 01-.418-.101l-4.201-2.175c-1.194-.618-2.126-1.31-2.853-2.118a9.617 9.617 0 01-2.496-6.386l-.048-7.742a2.114 2.114 0 011.431-1.997l7.715-2.69c.46-.164.97-.166 1.435-.008l7.745 2.598a2.11 2.11 0 011.457 1.978l.05 7.747a9.615 9.615 0 01-2.41 6.411c-.72.82-1.644 1.523-2.824 2.152l-4.164 2.224a.896.896 0 01-.418.107z", fill: "currentColor" }),
        React.createElement("path", { d: "M15.246 13.68l1.584-1.544a.841.841 0 000-1.213.898.898 0 00-1.246 0L14 12.465l-1.584-1.542a.898.898 0 00-1.246 0 .841.841 0 000 1.213l1.585 1.543-1.585 1.543a.841.841 0 000 1.213.89.89 0 00.624.252.89.89 0 00.622-.252L14 14.893l1.584 1.542a.888.888 0 00.623.252.89.89 0 00.623-.252.841.841 0 000-1.213l-1.584-1.543z", fill: "currentColor" })));
}

function SvgShow(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, fillRule: "evenodd", clipRule: "evenodd", d: "M20.693 7.054c1.992 1.537 3.688 3.79 4.905 6.607a.85.85 0 010 .667c-2.435 5.634-6.772 9.005-11.598 9.005h-.011c-4.815 0-9.151-3.371-11.587-9.005a.85.85 0 010-.667c2.436-5.635 6.772-8.994 11.587-8.994H14c2.413 0 4.701.837 6.693 2.387zM9.447 14c0 2.489 2.038 4.514 4.553 4.514 2.504 0 4.542-2.025 4.542-4.514 0-2.5-2.038-4.525-4.542-4.525-2.515 0-4.553 2.025-4.553 4.525z", fill: "currentColor" }),
        React.createElement("path", { d: "M16.836 13.996c0 1.55-1.275 2.817-2.834 2.817-1.57 0-2.846-1.267-2.846-2.817 0-.192.023-.372.057-.553h.057a2.33 2.33 0 002.334-2.241c.125-.021.262-.034.398-.034a2.836 2.836 0 012.834 2.828z", fill: "currentColor" })));
}

function SvgStar(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M15.14 3.633l2.597 5.22c.191.378.556.64.978.699l5.834.85c.34.047.65.227.86.501.206.271.294.614.244.952-.04.28-.173.539-.374.737l-4.228 4.099c-.31.286-.45.71-.375 1.124l1.041 5.761a1.3 1.3 0 01-1.04 1.484 1.363 1.363 0 01-.834-.133l-5.204-2.712a1.364 1.364 0 00-1.23 0l-5.204 2.712c-.64.34-1.431.108-1.787-.522a1.32 1.32 0 01-.136-.816l1.041-5.763a1.238 1.238 0 00-.374-1.125L2.72 12.605a1.265 1.265 0 01-.034-1.788l.034-.034c.2-.204.464-.334.749-.367l5.835-.851a1.3 1.3 0 00.978-.7l2.504-5.232a1.291 1.291 0 011.186-.716h.157c.435.053.814.322 1.01.716z", fill: "currentColor" }),
        React.createElement("path", { d: "M13.99 22.07a1.43 1.43 0 00-.643.176l-5.18 2.706a1.35 1.35 0 01-1.747-.539 1.29 1.29 0 01-.135-.809l1.035-5.75c.07-.418-.07-.843-.374-1.138l-4.23-4.094a1.275 1.275 0 010-1.82c.2-.2.459-.33.737-.37l5.84-.86c.423-.054.79-.318.976-.7l2.538-5.298A1.29 1.29 0 0114 2.919c-.01.346-.01 18.915-.01 19.151z", fill: "currentColor" })));
}

function SvgSwap(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M7.823 15.039c-.602 0-1.09.495-1.09 1.106l-.3 5.342a1.4 1.4 0 001.39 1.409c.768 0 1.389-.63 1.389-1.41l-.3-5.341c0-.611-.487-1.106-1.089-1.106z", fill: "currentColor" }),
        React.createElement("path", { d: "M9.31 4.286s-.312-.322-.506-.462a1.6 1.6 0 00-.973-.324c-.388 0-.749.122-1.042.352-.054.054-.28.258-.467.448-1.174 1.11-3.096 4.007-3.683 5.524-.092.23-.293.812-.305 1.124 0 .297.065.582.199.852.187.338.48.61.827.758.24.096.96.244.974.244.788.15 2.068.23 3.483.23 1.348 0 2.575-.08 3.375-.202.014-.014.907-.162 1.214-.326.56-.298.908-.88.908-1.502v-.054c-.014-.406-.362-1.26-.374-1.26-.587-1.435-2.416-4.265-3.63-5.402z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M20.177 12.961c.602 0 1.09-.495 1.09-1.106l.299-5.342c0-.778-.621-1.409-1.389-1.409a1.4 1.4 0 00-1.39 1.41l.3 5.341c0 .611.488 1.106 1.09 1.106z", fill: "currentColor" }),
        React.createElement("path", { d: "M25.468 16.2a1.746 1.746 0 00-.828-.758c-.24-.096-.961-.244-.973-.244-.788-.15-2.069-.23-3.484-.23-1.347 0-2.575.08-3.375.202-.013.014-.906.163-1.214.326-.56.297-.907.88-.907 1.503v.054c.013.406.36 1.258.374 1.258.587 1.436 2.414 4.267 3.629 5.403 0 0 .312.322.506.46.28.218.627.326.975.326.387 0 .746-.122 1.04-.352.054-.054.28-.258.468-.446 1.172-1.112 3.095-4.01 3.68-5.525.095-.23.296-.814.308-1.124a1.9 1.9 0 00-.2-.854z", fill: "currentColor" })));
}

function SvgSwitch(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 20 20", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("g", { clipPath: "url(#Switch_svg__clip0)" },
            React.createElement("path", { d: "M12.917 12.817V7.183L15.733 10l-2.816 2.817zm-1.25 3.016L17.5 10l-5.833-5.833v11.666zm-3.334 0V4.167L2.5 10l5.833 5.833z", fill: "currentColor" })),
        React.createElement("defs", null,
            React.createElement("clipPath", { id: "Switch_svg__clip0" },
                React.createElement("path", { fill: "#fff", d: "M0 0h20v20H0z" })))));
}

function SvgTarget(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 24 24", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M23.5 12c0 6.351-5.149 11.5-11.5 11.5S.5 18.351.5 12 5.649.5 12 .5 23.5 5.649 23.5 12z", stroke: "currentColor", strokeLinecap: "round", strokeLinejoin: "round" }),
        React.createElement("path", { d: "M18.7 12a6.7 6.7 0 11-13.4 0 6.7 6.7 0 0113.4 0z", fill: "currentColor", fillOpacity: 0.2, stroke: "currentColor", strokeLinecap: "round", strokeLinejoin: "round" }),
        React.createElement("path", { d: "M12 14.402a2.4 2.4 0 100-4.8 2.4 2.4 0 000 4.8z", fill: "currentColor" })));
}

function SvgTickSquare(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M19.064 2.333H8.948c-3.955 0-6.615 2.777-6.615 6.907v9.531c0 4.119 2.66 6.895 6.615 6.895h10.116c3.954 0 6.603-2.776 6.603-6.895V9.24c0-4.13-2.649-6.907-6.604-6.907z", fill: "currentColor" }),
        React.createElement("path", { d: "M12.615 17.79c-.26 0-.522-.1-.722-.3l-2.768-2.768a1.02 1.02 0 010-1.443 1.02 1.02 0 011.443-.001l2.047 2.047 4.816-4.816a1.021 1.021 0 011.443 1.444l-5.536 5.538c-.2.2-.461.298-.723.298z", fill: "currentColor" })));
}

function SvgTicketStar(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M24.792 15.722a1.731 1.731 0 01-1.737-1.72c0-.951.779-1.723 1.737-1.723a.88.88 0 00.618-.254.864.864 0 00.257-.613l-.001-3.124c0-2.64-2.17-4.788-4.834-4.788H7.168c-2.665 0-4.833 2.148-4.833 4.788l-.002 3.224c0 .23.093.451.257.614a.879.879 0 00.619.253c.99 0 1.737.697 1.737 1.622 0 .95-.78 1.721-1.737 1.721a.871.871 0 00-.876.868v3.12c0 2.641 2.168 4.79 4.834 4.79h13.666c2.666 0 4.834-2.149 4.834-4.79v-3.12a.871.871 0 00-.875-.868z", fill: "currentColor" }),
        React.createElement("path", { d: "M18.002 13.52l-1.375 1.34.325 1.893a.854.854 0 01-.345.845.851.851 0 01-.91.064L14 16.769l-1.701.894a.86.86 0 01-.4.101.861.861 0 01-.507-.165.859.859 0 01-.344-.846l.324-1.894-1.375-1.339a.857.857 0 01-.218-.887.86.86 0 01.7-.585l1.897-.277.85-1.723a.862.862 0 01.773-.48h.003c.33 0 .626.185.772.481l.85 1.722 1.901.278c.325.045.593.27.696.584a.853.853 0 01-.219.887z", fill: "currentColor" })));
}

function SvgTicket(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M16.042 11.32V8.964c-.462 0-.846-.373-.846-.822V5.336a.674.674 0 00-.688-.669H6.756c-2.437 0-4.423 1.928-4.423 4.297V11.8c0 .22.09.429.249.582.158.153.372.24.598.24.857 0 1.512.592 1.512 1.37 0 .813-.666 1.46-1.501 1.47-.463 0-.857.317-.857.777v2.807c0 2.368 1.985 4.286 4.411 4.286h7.763a.675.675 0 00.688-.669v-2.368c0-.46.384-.822.846-.822v-2.126c-.462 0-.846-.373-.846-.822v-4.384c0-.45.384-.822.846-.822z", fill: "currentColor" }),
        React.createElement("path", { d: "M23.309 13.994c0 .811.677 1.458 1.5 1.469.463 0 .858.318.858.767v2.817c0 2.368-1.975 4.286-4.412 4.286h-3.678a.682.682 0 01-.688-.67v-2.367c0-.46-.373-.822-.847-.822V17.35a.834.834 0 00.847-.822v-4.384a.833.833 0 00-.847-.822V8.963a.833.833 0 00.847-.822V5.336c0-.373.316-.67.688-.67h3.678c2.437 0 4.412 1.919 4.412 4.286v2.762c0 .22-.09.429-.248.581a.858.858 0 01-.598.241c-.835 0-1.512.659-1.512 1.458z", fill: "currentColor" })));
}

function SvgTimeCircle(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M25.666 14c0 6.445-5.223 11.666-11.666 11.666-6.444 0-11.667-5.221-11.667-11.666C2.333 7.558 7.556 2.333 14 2.333c6.443 0 11.666 5.225 11.666 11.667z", fill: "currentColor" }),
        React.createElement("path", { d: "M18.169 18.45a.881.881 0 01-.448-.122l-4.58-2.733a.88.88 0 01-.426-.752V8.955a.875.875 0 011.75 0v5.39l4.153 2.478a.877.877 0 01-.449 1.627z", fill: "currentColor" })));
}

function SvgTimeSquare(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M19.064 2.333H8.948c-3.955 0-6.615 2.777-6.615 6.907v9.531c0 4.119 2.66 6.895 6.615 6.895h10.116c3.954 0 6.603-2.776 6.603-6.895V9.24c0-4.13-2.649-6.907-6.604-6.907z", fill: "currentColor" }),
        React.createElement("path", { d: "M18.17 18.45a.882.882 0 01-.449-.122l-4.58-2.733a.88.88 0 01-.426-.752V8.955a.875.875 0 011.75 0v5.39l4.153 2.478a.877.877 0 01-.449 1.627z", fill: "currentColor" })));
}

function SvgUnlock(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M19.556 7.608a.899.899 0 01-1.14-.537c-.628-1.785-2.336-2.988-4.258-2.988h-.023c-2.48 0-4.496 1.973-4.508 4.411v1.574h-.012a5.5 5.5 0 00-1.767.292V8.517c.012-3.43 2.835-6.184 6.287-6.184h.023c2.681 0 5.066 1.669 5.943 4.166a.86.86 0 01-.545 1.109z", fill: "currentColor" }),
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M9.469 10.069h9.063c2.977 0 5.385 2.368 5.385 5.296v5.005c0 2.917-2.408 5.297-5.386 5.297H9.47c-2.978 0-5.385-2.38-5.385-5.297v-5.005c0-2.321 1.506-4.281 3.617-5.005a5.498 5.498 0 011.768-.291zM14 20.183c.57 0 1.032-.466 1.032-1.026v-2.59c0-.56-.462-1.027-1.032-1.027-.57 0-1.044.467-1.044 1.027v2.59c0 .56.475 1.026 1.044 1.026z", fill: "currentColor" })));
}

function SvgUpload(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M7.522 25.667c-2.86 0-5.189-2.369-5.189-5.279V14.6c0-2.904 2.322-5.267 5.177-5.267h12.969c2.86 0 5.188 2.369 5.188 5.28V20.4c0 2.905-2.322 5.268-5.177 5.268H7.522z", fill: "currentColor" }),
        React.createElement("path", { d: "M13.364 2.591L9.97 5.911a.858.858 0 00.003 1.238c.352.34.92.34 1.27-.003l1.859-1.819V16.861c0 .482.402.874.898.874a.886.886 0 00.898-.875V5.327l1.859 1.82a.916.916 0 001.27.002.863.863 0 00.265-.62.864.864 0 00-.262-.618l-3.393-3.32a.913.913 0 00-1.273 0z", fill: "currentColor" })));
}

function SvgUser2(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M10.908 17.334c-4.625 0-8.575.714-8.575 3.57 0 2.857 3.925 3.596 8.575 3.596 4.624 0 8.574-.714 8.574-3.57 0-2.857-3.925-3.596-8.574-3.596z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M10.908 14.612c3.15 0 5.673-2.472 5.673-5.556S14.057 3.5 10.908 3.5 5.234 5.972 5.234 9.056c0 3.085 2.525 5.556 5.674 5.556zM18.87 9.157c0 1.57-.483 3.036-1.327 4.254-.088.125-.01.294.142.32.213.035.43.056.653.06 2.215.058 4.202-1.338 4.752-3.441.813-3.12-1.575-5.922-4.617-5.922-.33 0-.646.034-.954.095-.043.009-.088.03-.111.065-.03.046-.008.105.022.144a7.482 7.482 0 011.44 4.425z", fill: "currentColor" }),
        React.createElement("path", { d: "M25.41 17.698c-.406-.847-1.384-1.427-2.873-1.712-.702-.168-2.604-.406-4.372-.372-.026.003-.041.021-.044.032-.003.018.005.045.04.064.817.396 3.975 2.117 3.578 5.748a.241.241 0 00.273.27c.777-.108 2.777-.529 3.397-1.84a2.458 2.458 0 000-2.19z", fill: "currentColor" })));
}

function SvgUser3(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M13.94 16.963c-4.025 0-7.42.658-7.42 3.196 0 2.54 3.417 3.174 7.42 3.174 4.025 0 7.421-.657 7.421-3.196 0-2.54-3.418-3.174-7.42-3.174z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M13.94 14.545a4.908 4.908 0 004.911-4.94c0-2.741-2.185-4.938-4.91-4.938-2.726 0-4.911 2.197-4.911 4.939a4.908 4.908 0 004.91 4.939zM24.602 10.756c.706-2.774-1.362-5.265-3.994-5.265-.286 0-.56.032-.828.085-.035.009-.075.026-.096.058-.024.04-.006.093.02.128a6.775 6.775 0 011.245 3.933c0 1.397-.416 2.7-1.148 3.78a.185.185 0 00.125.286c.184.032.372.049.564.054 1.917.05 3.637-1.19 4.113-3.06z", fill: "currentColor" }),
        React.createElement("path", { d: "M26.61 17.286c-.35-.752-1.197-1.268-2.485-1.52-.608-.15-2.254-.36-3.784-.332-.023.003-.036.019-.038.03-.003.014.003.04.034.055.707.352 3.44 1.883 3.097 5.112-.015.14.097.26.236.24.673-.098 2.404-.471 2.94-1.637a2.243 2.243 0 000-1.948z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M8.219 5.576a4.1 4.1 0 00-.828-.085c-2.632 0-4.7 2.491-3.993 5.265.474 1.87 2.195 3.11 4.111 3.06.193-.006.382-.024.565-.055a.185.185 0 00.124-.285A6.725 6.725 0 017.05 9.695c0-1.46.455-2.818 1.246-3.933.025-.034.044-.088.019-.128-.021-.032-.06-.05-.096-.058z", fill: "currentColor" }),
        React.createElement("path", { d: "M3.875 15.765c-1.288.253-2.134.769-2.485 1.521a2.238 2.238 0 000 1.95c.537 1.163 2.268 1.538 2.94 1.634.14.02.25-.099.235-.24-.343-3.227 2.39-4.758 3.099-5.11.03-.017.035-.041.032-.057-.002-.01-.013-.026-.036-.028-1.532-.03-3.176.18-3.785.33z", fill: "currentColor" })));
}

function SvgVideo(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M24.886 8.683a1.613 1.613 0 00-1.601-.075l-1.73.873a1.888 1.888 0 00-1.036 1.699v6.805c0 .725.397 1.376 1.036 1.7l1.728.872a1.6 1.6 0 00.736.179 1.667 1.667 0 001.647-1.674v-8.957a1.67 1.67 0 00-.78-1.422z", fill: "currentColor" }),
        React.createElement("path", { d: "M13.89 23.333H7.131c-2.826 0-4.798-1.948-4.798-4.737V10.57c0-2.79 1.972-4.738 4.798-4.738h6.757c2.826 0 4.799 1.948 4.799 4.738v8.025c0 2.789-1.973 4.737-4.799 4.737z", fill: "currentColor" })));
}

function SvgVoice(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M22.787 11.463c-.624 0-1.13.5-1.13 1.116 0 4.169-3.435 7.56-7.656 7.56-4.223 0-7.657-3.391-7.657-7.56 0-.617-.506-1.116-1.13-1.116-.624 0-1.13.5-1.13 1.116 0 5.023 3.849 9.17 8.787 9.726v2.246c0 .616.505 1.116 1.13 1.116.624 0 1.13-.5 1.13-1.116v-2.246c4.936-.557 8.786-4.703 8.786-9.726 0-.617-.507-1.116-1.13-1.116z", fill: "currentColor" }),
        React.createElement("path", { d: "M13.796 17.753h.409c2.802 0 5.076-2.244 5.076-5.012V7.347c0-2.77-2.274-5.014-5.076-5.014h-.41c-2.802 0-5.076 2.244-5.076 5.014v5.394c0 2.768 2.274 5.012 5.077 5.012z", fill: "currentColor" })));
}

function SvgVoice4(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M13.796 17.753h.408a5.073 5.073 0 004.82-3.43.451.451 0 00-.435-.59h-1.257c-.4 0-.723-.32-.723-.713a.72.72 0 01.723-.715h1.219c.403 0 .73-.323.73-.721a.725.725 0 00-.73-.721h-1.219c-.4 0-.723-.32-.723-.715 0-.395.323-.715.723-.715h1.219c.403 0 .73-.323.73-.721a.725.725 0 00-.73-.721h-1.219c-.4 0-.723-.32-.723-.716 0-.394.323-.714.723-.714h1.322c.302 0 .52-.286.438-.575-.6-2.108-2.56-3.653-4.888-3.653h-.408c-2.804 0-5.077 2.244-5.077 5.014v5.393c0 2.769 2.273 5.013 5.077 5.013z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M22.787 11.463c-.624 0-1.13.5-1.13 1.116 0 4.169-3.435 7.56-7.656 7.56-4.223 0-7.657-3.391-7.657-7.56 0-.617-.506-1.116-1.13-1.116-.624 0-1.13.5-1.13 1.116 0 5.023 3.849 9.17 8.787 9.726v2.246c0 .616.505 1.116 1.13 1.116.624 0 1.13-.5 1.13-1.116v-2.246c4.936-.557 8.786-4.703 8.786-9.726 0-.617-.507-1.116-1.13-1.116z", fill: "currentColor" })));
}

function SvgVolumeDown(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M22.15 6.619c-.136-.236-.498-.143-.498.13.26 4.604.246 9.35 0 14.213 0 .273.362.366.499.132 1.154-1.988 2.038-4.49 2.038-7.24 0-2.746-.884-5.25-2.038-7.235z", fill: "currentColor" }),
        React.createElement("path", { d: "M18.057 7.47c-.06-.56-.12-1.14-.273-1.72-.414-1.385-1.56-2.25-2.79-2.25-.685-.002-1.552.41-2.043.828L8.875 7.662H6.742c-1.57 0-2.833 1.182-3.071 2.888-.203 1.638-.252 4.73 0 6.532.219 1.802 1.424 2.967 3.07 2.967h2.134l4.155 3.384c.426.362 1.178.777 1.87.777l.123.001c1.253 0 2.356-.897 2.77-2.28.157-.587.211-1.138.264-1.67l.056-.528c.212-1.71.212-10.055 0-11.754l-.056-.509z", fill: "currentColor" })));
}

function SvgVolumeOff(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M18.326 8.985c.022.157.042.304.052.499L7.031 20.857h-.262c-1.663 0-2.875-1.176-3.1-3.005-.25-1.83-.2-4.961 0-6.626.238-1.73 1.512-2.919 3.1-2.919H8.93l4.124-3.383c.5-.425 1.387-.827 2.074-.84 1.25 0 2.4.879 2.812 2.28.162.59.225 1.178.275 1.742l.1.801.01.078zm-1.154 7.303c.17-.165.546-.283.716-.24.459.116.549.776.541 1.295-.02 1.505-.07 2.552-.15 3.2l-.057.534-.001.01c-.053.536-.109 1.092-.268 1.684-.416 1.4-1.532 2.31-2.8 2.31l-.125-.001c-.701 0-1.461-.42-1.892-.788L11.6 23.101c-.584-.435-.411-1.129-.084-1.53.245-.3 3.183-3.005 4.727-4.425.523-.482.886-.816.93-.858z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M3.825 24.065a.947.947 0 000 1.327.985.985 0 00.662.275c.238 0 .488-.1.663-.275L25.395 5.1a.945.945 0 000-1.327.941.941 0 00-1.325 0L3.825 24.065z", fill: "currentColor" })));
}

function SvgVolumeUp(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M15.989 7.526c-.06-.568-.124-1.156-.278-1.744-.422-1.405-1.589-2.282-2.84-2.282-.699-.002-1.581.416-2.082.84l-4.15 3.38H4.468c-1.598 0-2.884 1.198-3.126 2.928-.207 1.661-.257 4.796 0 6.624.222 1.827 1.45 3.008 3.126 3.008H6.64l4.23 3.43c.433.368 1.2.789 1.904.789l.126.001c1.275 0 2.398-.91 2.82-2.31.16-.597.214-1.156.269-1.696l.056-.534c.216-1.735.216-10.196 0-11.918l-.056-.516z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M24.173 4.591c-.179-.307-.651-.184-.651.172.34 5.984.322 12.153 0 18.476 0 .354.472.478.651.17 1.506-2.581 2.66-5.835 2.66-9.409 0-3.573-1.154-6.826-2.66-9.409zM18.482 6.795c.265 4.67.25 9.48 0 14.41 0 .278.369.374.509.134 1.173-2.014 2.075-4.55 2.075-7.339 0-2.787-.902-5.325-2.075-7.337-.14-.24-.509-.146-.509.132z", fill: "currentColor" })));
}

function SvgWallet(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M25.663 9.771h-4.94c-2.3.004-4.162 1.82-4.166 4.062-.004 2.246 1.86 4.07 4.165 4.074h4.945v.356c0 3.92-2.376 6.237-6.397 6.237H8.731c-4.022 0-6.397-2.317-6.397-6.237V9.727C2.333 5.808 4.708 3.5 8.73 3.5h10.535c4.02 0 6.397 2.308 6.397 6.227v.044zm-17.8-.01h6.592a.882.882 0 00.89-.874.883.883 0 00-.898-.866H7.863a.882.882 0 00-.889.867.882.882 0 00.889.874z", fill: "currentColor" }),
        React.createElement("path", { opacity: 0.4, d: "M18.71 14.346c.244 1.11 1.217 1.89 2.328 1.87h3.792a.846.846 0 00.837-.856v-2.953a.85.85 0 00-.837-.857h-3.881c-1.264.004-2.284 1.053-2.282 2.345 0 .152.015.303.043.451z", fill: "currentColor" }),
        React.createElement("circle", { cx: 21, cy: 13.883, fill: "currentColor", r: 1.167 })));
}

function SvgWork(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 28 28", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { opacity: 0.4, d: "M2.333 12.925c.059 2.728.222 7.393.245 7.908.083 1.1.505 2.212 1.16 2.996.913 1.1 2.036 1.59 3.603 1.59 2.165.013 4.552.013 6.87.013 2.328 0 4.586 0 6.494-.012 1.545 0 2.703-.504 3.604-1.591.655-.784 1.077-1.908 1.136-2.996.023-.433.14-5.498.21-7.908H2.333z", fill: "currentColor" }),
        React.createElement("path", { d: "M13.12 17.948v1.51a.875.875 0 001.75 0v-1.51a.875.875 0 00-1.75 0z", fill: "currentColor" }),
        React.createElement("path", { fillRule: "evenodd", clipRule: "evenodd", d: "M11.913 16.983a.875.875 0 01-.965.635c-2.976-.415-5.82-1.47-8.221-3.056a.872.872 0 01-.393-.73V9.787a4.453 4.453 0 014.453-4.443h2.295c.219-1.694 1.654-3.011 3.406-3.011h3.013c1.75 0 3.187 1.317 3.406 3.011h2.307a4.447 4.447 0 014.441 4.443v4.043a.878.878 0 01-.392.73c-2.405 1.593-5.261 2.654-8.257 3.068a.875.875 0 01-.968-.651 2.106 2.106 0 00-2.05-1.579 2.13 2.13 0 00-2.075 1.584zm3.588-12.9h-3.013a1.7 1.7 0 00-1.637 1.262h6.285a1.7 1.7 0 00-1.635-1.261z", fill: "currentColor" })));
}

function SvgXlsx(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 32 32", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M7.548 29h16.687c.855 0 1.548-.693 1.548-1.547V8.483l-3.018-2.513L19.23 3H7.548C6.693 3 6 3.693 6 4.548v22.904C6 28.308 6.693 29 7.548 29z", fill: "currentColor" }),
        React.createElement("path", { d: "M11.76 19l-.843-1.244L10.194 19H9.086l1.277-2.057-1.317-1.94h1.148l.82 1.205.706-1.204h1.102l-1.26 2.012L12.907 19h-1.148zm2.488-.74h1.288V19h-2.255v-3.996h.967v3.256zm4.604-.385a1.114 1.114 0 01-.639 1.006c-.207.106-.46.159-.758.159-.448 0-.817-.11-1.107-.328-.29-.219-.449-.524-.475-.916H16.9a.55.55 0 00.159.356c.094.087.213.13.356.13a.41.41 0 00.294-.102.356.356 0 00.107-.27.345.345 0 00-.102-.255.707.707 0 00-.243-.164 4.716 4.716 0 00-.407-.158 5.587 5.587 0 01-.621-.25 1.21 1.21 0 01-.413-.36c-.113-.163-.17-.372-.17-.628 0-.238.06-.443.181-.616.121-.174.287-.305.498-.396.215-.094.46-.141.735-.141.444 0 .797.105 1.056.316.264.211.413.501.447.87h-1.046a.514.514 0 00-.147-.31.409.409 0 00-.31-.119.415.415 0 00-.277.09c-.068.06-.102.15-.102.266 0 .094.03.175.09.243a.77.77 0 00.238.159c.094.041.23.094.407.158.256.086.465.173.627.26.162.083.302.205.418.367.117.162.176.373.176.633zM21.81 19l-.843-1.244L20.245 19h-1.108l1.278-2.057-1.317-1.94h1.147l.82 1.205.706-1.204h1.102l-1.26 2.012L22.958 19h-1.147z", fill: "#fff" }),
        React.createElement("path", { d: "M19.225 6.985L19.206 3l6.526 5.545-4.966-.02a1.547 1.547 0 01-1.541-1.54z", fill: "currentColor" })));
}

function SvgAttachment(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 24 24", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M16.5 6v11.5c0 2.21-1.79 4-4 4s-4-1.79-4-4V5a2.5 2.5 0 015 0v10.5c0 .55-.45 1-1 1s-1-.45-1-1V6H10v9.5a2.5 2.5 0 005 0V5c0-2.21-1.79-4-4-4S7 2.79 7 5v12.5c0 3.04 2.46 5.5 5.5 5.5s5.5-2.46 5.5-5.5V6h-1.5z", fill: "currentColor" })));
}

function SvgFavorite(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 24 24", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M16.5 3c-1.74 0-3.41.81-4.5 2.09C10.91 3.81 9.24 3 7.5 3 4.42 3 2 5.42 2 8.5c0 3.78 3.4 6.86 8.55 11.54L12 21.35l1.45-1.32C18.6 15.36 22 12.28 22 8.5 22 5.42 19.58 3 16.5 3zm-4.4 15.55l-.1.1-.1-.1C7.14 14.24 4 11.39 4 8.5 4 6.5 5.5 5 7.5 5c1.54 0 3.04.99 3.57 2.36h1.87C13.46 5.99 14.96 5 16.5 5c2 0 3.5 1.5 3.5 3.5 0 2.89-3.14 5.74-7.9 10.05z", fill: "currentColor" })));
}

function SvgNextPlan(_a) {
    var title = _a.title, titleId = _a.titleId, props = __rest(_a, ["title", "titleId"]);
    return (React.createElement("svg", __assign({ width: "1em", height: "1em", viewBox: "0 0 24 24", fill: "none", xmlns: "http://www.w3.org/2000/svg", "aria-labelledby": titleId }, props),
        title ? React.createElement("title", { id: titleId }, title) : null,
        React.createElement("path", { d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm6 11.97h-5l2.26-2.26a4.94 4.94 0 00-3.76-1.74c-2.37 0-4.35 1.66-4.86 3.88l-.96-.32c.64-2.62 3-4.56 5.82-4.56 1.78 0 3.37.79 4.47 2.03L18 8.97v5z", fill: "currentColor" })));
}

export { SvgActivity as Activity, SvgAddUser as AddUser, SvgArrow as Arrow, SvgArrowDown as ArrowDown, SvgArrowDown6 as ArrowDown6, SvgArrowDown7 as ArrowDown7, SvgArrowDownCircle as ArrowDownCircle, SvgArrowDownSquare as ArrowDownSquare, SvgArrowLeft as ArrowLeft, SvgArrowLeft6 as ArrowLeft6, SvgArrowLeft7 as ArrowLeft7, SvgArrowLeftCircle as ArrowLeftCircle, SvgArrowLeftRounded as ArrowLeftRounded, SvgArrowLeftSquare as ArrowLeftSquare, SvgArrowRight as ArrowRight, SvgArrowRight6 as ArrowRight6, SvgArrowRight7 as ArrowRight7, SvgArrowRightCircle as ArrowRightCircle, SvgArrowRightSquare as ArrowRightSquare, SvgArrowUp as ArrowUp, SvgArrowUp6 as ArrowUp6, SvgArrowUp7 as ArrowUp7, SvgArrowUpCircle as ArrowUpCircle, SvgArrowUpSquare as ArrowUpSquare, SvgAttachment as Attachment, SvgAward as Award, SvgBag as Bag, SvgBag4 as Bag4, SvgBookmark as Bookmark, SvgBookmark1 as Bookmark1, SvgBuy as Buy, SvgCalendar as Calendar, SvgCalendar1 as Calendar1, SvgCall as Call, SvgCallMissed as CallMissed, SvgCallSilent as CallSilent, SvgCalling as Calling, SvgCamera as Camera, SvgCategory as Category, SvgChart as Chart, SvgChat as Chat, SvgCheckRoundedOutline as CheckRoundedOutline, SvgCloseSquare as CloseSquare, SvgComment as Comment, SvgDanger as Danger, SvgDelete as Delete, SvgDisableIcon as DisableIcon, SvgDiscount as Discount, SvgDiscovery as Discovery, SvgDocument as Document, SvgDocx as Docx, SvgDone as Done, SvgDownload as Download, SvgDownload1 as Download1, SvgEdit as Edit, SvgEditSquare as EditSquare, SvgExpand as Expand, SvgEyeRounded as EyeRounded, SvgFavorite as Favorite, SvgFilter as Filter, SvgFilter4 as Filter4, SvgFolder as Folder, SvgGame as Game, SvgGraph as Graph, SvgHeart as Heart, SvgHelp as Help, SvgHide as Hide, SvgHome as Home, SvgImage as Image, SvgImage4 as Image4, SvgInfoCircle as InfoCircle, SvgInfoCircleOutline as InfoCircleOutline, SvgInfoSquare as InfoSquare, SvgLocation as Location, SvgLock as Lock, SvgLogin as Login, SvgLogout as Logout, SvgMenu as Menu, SvgMessage as Message, SvgMoreCircle as MoreCircle, SvgMoreSquare as MoreSquare, SvgMov as Mov, SvgNextPlan as NextPlan, SvgNotification as Notification, SvgOut as Out, SvgPaper as Paper, SvgPaperDownload as PaperDownload, SvgPaperFail as PaperFail, SvgPaperNegative as PaperNegative, SvgPaperPlus as PaperPlus, SvgPaperSuccess as PaperSuccess, SvgPaperUpload as PaperUpload, SvgPassword as Password, SvgPdf as Pdf, SvgPeopleSetting as PeopleSetting, SvgPlay as Play, SvgPlus as Plus, SvgPptx as Pptx, SvgPreview as Preview, SvgProfile as Profile, SvgRemove as Remove, SvgRemoveIcon as RemoveIcon, SvgScan as Scan, SvgSearch as Search, SvgSearchOutline as SearchOutline, SvgSearchSingleLine as SearchSingleLine, SvgSend as Send, SvgSetting as Setting, SvgShieldDone as ShieldDone, SvgShieldFail as ShieldFail, SvgShow as Show, SvgStar as Star, SvgSwap as Swap, SvgSwitch as Switch, SvgTarget as Target, SvgTickSquare as TickSquare, SvgTicket as Ticket, SvgTicketStar as TicketStar, SvgTimeCircle as TimeCircle, SvgTimeSquare as TimeSquare, SvgUnlock as Unlock, SvgUpload as Upload, SvgUser2 as User2, SvgUser3 as User3, SvgVideo as Video, SvgVoice as Voice, SvgVoice4 as Voice4, SvgVolumeDown as VolumeDown, SvgVolumeOff as VolumeOff, SvgVolumeUp as VolumeUp, SvgWallet as Wallet, SvgWork as Work, SvgXlsx as Xlsx };
